#include <gb.h>
#include "u3.h"


#define u3tiles ((unsigned char*)(0xB000))
#define tile_palettes ((unsigned char*)(0xB930))
#define tile_attribs  ((unsigned char*)(0xB990))
#define check_order ((unsigned char*)(0xB9F0))
#define bkg_p ((UWORD*)(0xBA40))
#define obj_p ((UWORD*)(0xBA80))
#define battlemaps ((UWORD*)(0xBAC0))
#define smallmapdat ((unsigned char*)(0xA800))
#define SCROLLDELAY 20

unsigned char currdungtile ;

extern UBYTE mode4tiles ;
extern UBYTE mode8tiles ;
extern UBYTE screenx ;
extern UBYTE screeny;
extern UBYTE playerx ;
extern UBYTE playery ;
extern UBYTE changemusic ;

extern UBYTE transport ; //0=walking, 1=ship, 2=horse
extern UBYTE need_refresh ;
extern UBYTE delayscroll ;
extern UBYTE moves ;
extern UBYTE inside ;
extern UBYTE dir ;
extern UBYTE moon1 ;
extern UBYTE moon2 ;
extern UBYTE nummonsters ;
extern UBYTE numplayers ;
extern UBYTE stoptime ;
extern UBYTE stoptimebattle ;

extern UBYTE dunglevel ;
extern UBYTE dungx ;
extern UBYTE dungy ;
extern UBYTE dungdir ;
extern UBYTE dungnumber ;
extern UBYTE dungrefresh ;
extern UBYTE torchtime ;

extern unsigned char *vidbase ;
extern unsigned char screenbuf3[] ;

extern PLAYER players[] ;
extern MONSTER monsters[] ;

extern BATTLEMONSTERS baddies[9] ;
//extern BATTLEPLAYERS  goodies[4] ;
extern UBYTE numbaddies ;
extern UBYTE numgoodies ;
extern UBYTE numalive ;

extern UBYTE playerslocs ;
extern UBYTE monsterslocs ;
extern UBYTE monsterpower ;
extern UBYTE monstertile ;
extern UBYTE monsterexp ;
extern UBYTE monsterstat ;
extern UBYTE monsterattrib ;
extern UBYTE masskill ;
extern UBYTE mapnum ;
extern UBYTE moonchanges ;

unsigned char killeddat2[] = {
	'K'+0x1D,'I'+0x1D,'L'+0x1D,'L'+0x1D,'E'+0x1D,'D'+0x1D,0x82,0x5d,0x5d,0x5d,0x5d,0x5d
} ;
unsigned char leftmarkdat[] = {
	'M'+0x1D,'A'+0x1D,'D'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,0x5D,'M'+0x1D,'A'+0x1D,'R'+0x1D,'K'+0x1D,0x82
} ;

unsigned char dung26[] = {
	0x7F,0x00,0x7F,0x00,0x5F,0x00,0x4F,0x00,0x47,0x00,0x43,0x00,0x43,0x00,0x43,0x00
};

unsigned char dung2a[] = {
	0xC2,0x00,0xC2,0x00,0xC2,0x00,0xC2,0x00,0xC2,0x00,0xC2,0x00,0xC2,0x00,0xC2,0x00
};
unsigned char dung32[] = {
	0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00
};

unsigned char timelordmap[] = {
	0x5d,0x5d,0x26,0x26,0x26,0x26,0x26,0x26,0x26,0x5d,0x5d,
	0x5d,0x26,0x26,0x5d,0x5d,0x5d,0x5d,0x5d,0x26,0x26,0x5d,
	0x26,0x26,0x5d,0x5d,0x3a,0x3a,0x3a,0x5d,0x5d,0x26,0x26,
	0x26,0x5d,0x5d,0x5d,0x3a,0x3a,0x3a,0x5d,0x5d,0x5d,0x26,
	0x26,0x5d,0x5d,0x5d,0x3a,0x3a,0x3a,0x5d,0x5d,0x5d,0x26,
	0x26,0x5d,0x5d,0x5d,0x5d,0x3a,0x5d,0x5d,0x5d,0x5d,0x26,
	0x26,0x5d,0x3a,0x3a,0x3a,0x3a,0x3a,0x3a,0x3a,0x5d,0x26,
	0x26,0x3a,0x5d,0x3a,0x3a,0x32,0x3a,0x3a,0x5d,0x3a,0x26,
	0x26,0x3a,0x5d,0x5d,0x3a,0x3a,0x3a,0x5d,0x5d,0x3a,0x26,
	0x26,0x3a,0x5d,0x5d,0x5d,0x3a,0x5d,0x5d,0x5d,0x3a,0x26,
	0x26,0x3a,0x5d,0x5d,0x3a,0x3a,0x3a,0x5d,0x5d,0x3a,0x26
};

unsigned char fountainmap[] = {
	0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,
	0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,
	0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,
	0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x3A,0x5d,
	0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x00,0x00,0x3a,0x5d,
	0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x00,0x00,0x5d,0x3a,0x5d,
	0x5d,0x5d,0x5d,0x5d,0x5d,0x00,0x00,0x5d,0x5d,0x3a,0x5d,
	0x5d,0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x3a,0x3a,0x5d,
	0x5d,0x3a,0x3a,0x00,0x00,0x00,0x00,0x3a,0x3a,0x5d,0x5d,
	0x5d,0x5d,0x3a,0x3a,0x3a,0x3a,0x3a,0x3a,0x5d,0x5d,0x5d,
	0x5d,0x5d,0x5d,0x3a,0x5d,0x5d,0x3a,0x5d,0x5d,0x5d,0x5d,

};

unsigned char timedat1[] = {
	'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,'S'+0x1D,'E'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,0x5d,0x5d,0x5d
} ;

unsigned char timedat2[] = {
	'V'+0x1D,'I'+0x1D,'S'+0x1D,'I'+0x1D,'O'+0x1D,'N'+0x1D,0x8A,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5d
} ;

unsigned char timedat3[] = {
	'T'+0x1D,'I'+0x1D,'M'+0x1D,'E'+0x1D,0x5D,'L'+0x1D,'O'+0x1D,'R'+0x1D,'D'+0x1D,0x5d,0x5d,0x5d
};

unsigned char timedat4[] = {
	'H'+0x1D,'E'+0x1D,0x5D,'T'+0x1D,'E'+0x1D,'L'+0x1D,'L'+0x1D,'S'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D
};

unsigned char timedat5[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,'O'+0x1D,'N'+0x1D,'E'+0x1D,0x5D,'W'+0x1D,'A'+0x1D,'Y'+0x1D,0x5d
};

unsigned char timedat6[] = {
	'I'+0x1D,'S'+0x1D,0x5D,'L'+0x1D,'O'+0x1D,'V'+0x1D,'E'+0x1D,0x5D,'S'+0x1D,'O'+0x1D,'L'+0x1D,0x5d
} ;

unsigned char timedat7[] = {
	'M'+0x1D,'O'+0x1D,'O'+0x1D,'N'+0x1D,'S'+0x1D,0x5D,'D'+0x1D,'E'+0x1D,'A'+0x1D,'T'+0x1D,'H'+0x1D,0x5d
} ;

unsigned char markdat1[] = {
	'A'+0x1D,0x5D,'R'+0x1D,'E'+0x1D,'D'+0x1D,0x5D,'H'+0x1D,'O'+0x1D,'T'+0x1D,0x5d,0x5d,0x5d
} ;

unsigned char markdat2[] = {
	'R'+0x1D,'O'+0x1D,'D'+0x1D,0x5D,'I'+0x1D,'N'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5d,0x5d
} ;

unsigned char markdat3[] = {
	'W'+0x1D,'A'+0x1D,'L'+0x1D,'L'+0x1D,0x84,0x5D,'W'+0x1D,'H'+0x1D,'O'+0x1D,0x5d,0x5d,0x5d
} ;

unsigned char markdat4[] = {
	'W'+0x1D,'I'+0x1D,'L'+0x1D,'L'+0x1D,0x5D,'T'+0x1D,'O'+0x1D,'U'+0x1D,'C'+0x1D,'H'+0x1D,0x83,0x5d
} ;

unsigned char cantdat[] = {
	'C'+0x1D,'A'+0x1D,'N'+0x1D,0x86,'T'+0x1D,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d
};

unsigned char fountres1[] = {
	'T'+0x1D,'H'+0x1D,'A'+0x1D,'T'+0x1D,0x86,'S'+0x1D,0x5D,'N'+0x1D,'I'+0x1D,'C'+0x1D,'E'+0x1D,0x82
};
unsigned char fountres2[] = {
	'H'+0x1D,'O'+0x1D,'R'+0x1D,'R'+0x1D,'I'+0x1D,'B'+0x1D,'L'+0x1D,'E'+0x1D,0x82,0x5d,0x5d,0x5d
};
unsigned char fountres3[] = {
	'W'+0x1D,'O'+0x1D,'N'+0x1D,'D'+0x1D,'E'+0x1D,'R'+0x1D,'F'+0x1D,'U'+0x1D,'L'+0x1D,0x82,0x5d,0x5d
};
unsigned char fountres4[] = {
	'A'+0x1D,'R'+0x1D,'G'+0x1D,'H'+0x1D,0x82,0x5D,'B'+0x1D,'L'+0x1D,'A'+0x1D,'H'+0x1D,0x82,0x5d
}; //-25 

unsigned char gremlinsdat[] = {
	'G'+0x1D,'R'+0x1D,'E'+0x1D,'M'+0x1D,'L'+0x1D,'I'+0x1D,'N'+0x1D,'S'+0x1D,0x82,0x5d,0x5d,0x5d
};

unsigned char fountaindat1[] = {
	'F'+0x1D,'O'+0x1D,'U'+0x1D,'N'+0x1D,'T'+0x1D,'A'+0x1D,'I'+0x1D,'N'+0x1D,0x8A,'W'+0x1D,'H'+0x1D,'O'+0x1D
};

unsigned char fountaindat2[] = {
	'W'+0x1D,'I'+0x1D,'L'+0x1D,'L'+0x1D,0x5D,'D'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'K'+0x1D,0x83,0x5d
} ;

unsigned char deaddat5[] = {
	'P'+0x1D,'L'+0x1D,'A'+0x1D,'Y'+0x1D,'E'+0x1D,'R'+0x1D,0x5D,'D'+0x1D,'E'+0x1D,'A'+0x1D,'D'+0x1D,0x82 
} ;

unsigned char trapevadeddat[] = {
	'T'+0x1D,'R'+0x1D,'A'+0x1D,'P'+0x1D,0x5D,'E'+0x1D,'V'+0x1D,'A'+0x1D,'D'+0x1D,'E'+0x1D,'D'+0x1D,0x82
};

unsigned char mistydat[] = {
	'M'+0x1D,'I'+0x1D,'S'+0x1D,'T'+0x1D,'Y'+0x1D,0x5D,'W'+0x1D,'O'+0x1D,'R'+0x1D,'D'+0x1D,'S'+0x1D,0x8A
};

unsigned char strangewinddat[] = {
	'S'+0x1D,'T'+0x1D,'R'+0x1D,'A'+0x1D,'N'+0x1D,'G'+0x1D,'E'+0x1D,0x5D,'W'+0x1D,'I'+0x1D,'N'+0x1D,'D'+0x1D,
};

unsigned char trapdat[] = {
	'A'+0x1D,'R'+0x1D,'G'+0x1D,'H'+0x1D,0x82,0x5D,'T'+0x1D,'R'+0x1D,'A'+0x1D,'P'+0x1D,0x82,0x82
};

unsigned char dungtextdat[] = {
	0x5D,0x5D,'D'+0x1D,'A'+0x1D,'R'+0x1D,'D'+0x1D,'I'+0x1D,'N'+0x1D,0x86,'S'+0x1D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,'P'+0x1D,'I'+0x1D,'T'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'S'+0x1D,'E'+0x1D,'C'+0x1D,'R'+0x1D,'E'+0x1D,'T'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'S'+0x1D,'L'+0x1D,'I'+0x1D,'D'+0x1D,'E'+0x1D,'S'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'B'+0x1D,'E'+0x1D,'W'+0x1D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'T'+0x1D,'R'+0x1D,'A'+0x1D,'P'+0x1D,'S'+0x1D,0x82,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,'E'+0x1D,'V'+0x1D,'E'+0x1D,'R'+0x1D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,'A'+0x1D,'D'+0x1D,'V'+0x1D,'E'+0x1D,'N'+0x1D,'T'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,0x82,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,'G'+0x1D,'R'+0x1D,'E'+0x1D,'M'+0x1D,'L'+0x1D,'I'+0x1D,'N'+0x1D,'S'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'C'+0x1D,'I'+0x1D,'R'+0x1D,'C'+0x1D,'L'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'D'+0x1D,'E'+0x1D,'A'+0x1D,'T'+0x1D,'H'+0x1D,0x82,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'C'+0x1D,'O'+0x1D,'L'+0x1D,'O'+0x1D,'S'+0x1D,'S'+0x1D,'A'+0x1D,'L'+0x1D,0x5D,0x5D, 
	0x5D,0x5D,'C'+0x1D,'A'+0x1D,'V'+0x1D,'E'+0x1D,'R'+0x1D,'N'+0x1D,0x82,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'T'+0x1D,'R'+0x1D,'A'+0x1D,'P'+0x1D,'S'+0x1D,0x5D,'T'+0x1D,'O'+0x1D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,'G'+0x1D,'O'+0x1D,'L'+0x1D,'D'+0x1D,0x82,0x5D,0x5D,0x5D, 

	0x5D,'B'+0x1D,'E'+0x1D,'W'+0x1D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D, 
	'F'+0x1D,'I'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D,'H'+0x1D,'E'+0x1D,'L'+0x1D,'L'+0x1D, 
	0x5D,0x5D,'T'+0x1D,'R'+0x1D,'A'+0x1D,'P'+0x1D,'P'+0x1D,'E'+0x1D,'D'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'D'+0x1D,'O'+0x1D,'O'+0x1D,'R'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'T'+0x1D,'W'+0x1D,'I'+0x1D,'S'+0x1D,'T'+0x1D,'Y'+0x1D,0x5D,'M'+0x1D,'A'+0x1D,'Z'+0x1D,'E'+0x1D,0x82, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'W'+0x1D,'I'+0x1D,'N'+0x1D,'D'+0x1D,'Y'+0x1D,0x5D,'W'+0x1D,'A'+0x1D,'L'+0x1D,'K'+0x1D,0x82,0x5D, 
	0x5D,0x5D,'G'+0x1D,'R'+0x1D,'E'+0x1D,'M'+0x1D,'L'+0x1D,'I'+0x1D,'N'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'C'+0x1D,'I'+0x1D,'T'+0x1D,'Y'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'D'+0x1D,'E'+0x1D,'V'+0x1D,'I'+0x1D,'L'+0x1D,'S'+0x1D,0x5D,'D'+0x1D,'E'+0x1D,'N'+0x1D,0x82,0x5D, 
	0x5D,0x5D,'G'+0x1D,'O'+0x1D,0x5D,'B'+0x1D,'A'+0x1D,'C'+0x1D,'K'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'P'+0x1D,'I'+0x1D,'T'+0x1D,'S'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D, 
	0x5D,'C'+0x1D,'H'+0x1D,'A'+0x1D,'M'+0x1D,'B'+0x1D,'E'+0x1D,'R'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,'F'+0x1D,'I'+0x1D,'R'+0x1D,'E'+0x1D,0x82,0x5D,0x5D,0x5D, 

	'W'+0x1D,'E'+0x1D,'L'+0x1D,'C'+0x1D,'O'+0x1D,'M'+0x1D,'E'+0x1D,0x84,0x84,0x84,'T'+0x1D,'O'+0x1D, 
	'Y'+0x1D,'O'+0x1D,'U'+0x1D,'R'+0x1D,0x5D,'D'+0x1D,'O'+0x1D,'O'+0x1D,'M'+0x1D,0x82,0x82,0x82, 
	0x5D,0x5D,0x5D,'S'+0x1D,'E'+0x1D,'C'+0x1D,'R'+0x1D,'E'+0x1D,'T'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'C'+0x1D,'O'+0x1D,'R'+0x1D,'N'+0x1D,'E'+0x1D,'R'+0x1D,'S'+0x1D,0x82,0x5D,0x5D, 
	0x5D,'T'+0x1D,'R'+0x1D,'A'+0x1D,'P'+0x1D,'S'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,0x5D, 
	0x5D,'T'+0x1D,'R'+0x1D,'E'+0x1D,'A'+0x1D,'S'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,0x5D, 
	0x5D,'B'+0x1D,'E'+0x1D,'W'+0x1D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D, 
	0x5D,0x5D,0x5D,'W'+0x1D,'I'+0x1D,'N'+0x1D,'D'+0x1D,'S'+0x1D,0x82,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'D'+0x1D,'A'+0x1D,'N'+0x1D,'G'+0x1D,'E'+0x1D,'R'+0x1D,0x82,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,'M'+0x1D,'A'+0x1D,'P'+0x1D,0x5D,'W'+0x1D,'E'+0x1D,'L'+0x1D,'L'+0x1D,0x82,0x82,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,'R'+0x1D,'E'+0x1D,'A'+0x1D,'C'+0x1D,'H'+0x1D,0x5D,'U'+0x1D,'P'+0x1D,0x82,0x82,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'W'+0x1D,'I'+0x1D,'N'+0x1D,'D'+0x1D,'Y'+0x1D,0x5D,'S'+0x1D,'E'+0x1D,'C'+0x1D,'R'+0x1D,'E'+0x1D,'T'+0x1D, 

	0x5D,0x5D,'M'+0x1D,'I'+0x1D,'N'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D,0x5D, 
	0x5D,0x5D,'M'+0x1D,'O'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'I'+0x1D,'A'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'T'+0x1D,'E'+0x1D,'R'+0x1D,'R'+0x1D,'O'+0x1D,'R'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'T'+0x1D,'U'+0x1D,'N'+0x1D,'N'+0x1D,'E'+0x1D,'L'+0x1D,'S'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'L'+0x1D,'O'+0x1D,'N'+0x1D,'G'+0x1D,0x5D,'M'+0x1D,'A'+0x1D,'R'+0x1D,'C'+0x1D,'H'+0x1D,0x82,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'M'+0x1D,'I'+0x1D,'S'+0x1D,'T'+0x1D,'Y'+0x1D,0x5D,'M'+0x1D,'I'+0x1D,'N'+0x1D,'E'+0x1D,'S'+0x1D,0x82, 
	0x5D,0x5D,'M'+0x1D,'I'+0x1D,'N'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D,0x5D, 
	0x5D,0x5D,'M'+0x1D,'A'+0x1D,'D'+0x1D,'N'+0x1D,'E'+0x1D,'S'+0x1D,'S'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'G'+0x1D,0x85U,0x5D,'T'+0x1D,0x85U,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,'G'+0x1D,0x82, 
	0x5D,0x5D,0x5D,0x5D,'D'+0x1D,'A'+0x1D,'R'+0x1D,'K'+0x1D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'P'+0x1D,'R'+0x1D,'E'+0x1D,'V'+0x1D,'A'+0x1D,'I'+0x1D,'L'+0x1D,'S'+0x1D,0x82,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'D'+0x1D,'R'+0x1D,'Y'+0x1D,0x5D,'H'+0x1D,'O'+0x1D,'L'+0x1D,'E'+0x1D,0x5D,0x5D, 

	0x5D,0x5D,'P'+0x1D,'E'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'I'+0x1D,'A'+0x1D,'N'+0x1D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'D'+0x1D,'E'+0x1D,'P'+0x1D,'T'+0x1D,'H'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'G'+0x1D,'O'+0x1D,0x5D,'B'+0x1D,'A'+0x1D,'C'+0x1D,'K'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'N'+0x1D,'O'+0x1D,'T'+0x1D,0x5D,'H'+0x1D,'E'+0x1D,'R'+0x1D,'E'+0x1D,0x82,0x5D, 
	0x5D,0x5D,0x5D,'Q'+0x1D,'U'+0x1D,'A'+0x1D,'R'+0x1D,'T'+0x1D,'E'+0x1D,'R'+0x1D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,'E'+0x1D,'A'+0x1D,'C'+0x1D,'H'+0x1D,0x82,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,'D'+0x1D,'E'+0x1D,'A'+0x1D,'T'+0x1D,'H'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'A'+0x1D,'W'+0x1D,'A'+0x1D,'I'+0x1D,'T'+0x1D,'S'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'M'+0x1D,'A'+0x1D,'P'+0x1D,0x5D,'W'+0x1D,'E'+0x1D,'L'+0x1D,'L'+0x1D,0x82,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'G'+0x1D,'R'+0x1D,'E'+0x1D,'M'+0x1D,'L'+0x1D,'I'+0x1D,'N'+0x1D,'S'+0x1D,0x82,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'G'+0x1D,'O'+0x1D,0x5D,'B'+0x1D,'A'+0x1D,'C'+0x1D,'K'+0x1D,0x82,0x5D,0x5D, 

	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'T'+0x1D,'I'+0x1D,'M'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,'W'+0x1D,'A'+0x1D,'I'+0x1D,'T'+0x1D,'S'+0x1D,0x82, 
	0x5D,0x5D,'G'+0x1D,'R'+0x1D,'E'+0x1D,'M'+0x1D,'L'+0x1D,'I'+0x1D,'N'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'G'+0x1D,'O'+0x1D,'L'+0x1D,'D'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'G'+0x1D,'O'+0x1D,'L'+0x1D,'D'+0x1D,'E'+0x1D,'N'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'C'+0x1D,'E'+0x1D,'N'+0x1D,'T'+0x1D,'E'+0x1D,'R'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,'S'+0x1D,'T'+0x1D,'A'+0x1D,'I'+0x1D,'R'+0x1D,0x5D,'T'+0x1D,'O'+0x1D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'H'+0x1D,'E'+0x1D,'A'+0x1D,'V'+0x1D,'E'+0x1D,'N'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,'T'+0x1D,'I'+0x1D,'M'+0x1D,'E'+0x1D,0x5D,'R'+0x1D,'U'+0x1D,'N'+0x1D,'S'+0x1D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,'S'+0x1D,'H'+0x1D,'O'+0x1D,'R'+0x1D,'T'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'L'+0x1D,'O'+0x1D,'N'+0x1D,'G'+0x1D,0x5D,'M'+0x1D,'A'+0x1D,'R'+0x1D,'C'+0x1D,'H'+0x1D,0x82,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,'T'+0x1D,'R'+0x1D,'A'+0x1D,'P'+0x1D,0x82,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'V'+0x1D,'E'+0x1D,'R'+0x1D,'Y'+0x1D,0x5D,'N'+0x1D,'E'+0x1D,'A'+0x1D,'R'+0x1D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,'N'+0x1D,'O'+0x1D,'W'+0x1D,0x82,0x5D,0x5D,0x5D, 

	0x5D,0x5D,'C'+0x1D,'L'+0x1D,'U'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,'T'+0x1D,'O'+0x1D,0x5D,0x5D, 
	0x5D,0x5D,0x5D,'F'+0x1D,'O'+0x1D,'L'+0x1D,'L'+0x1D,'O'+0x1D,'W'+0x1D,0x82,0x5D,0x5D, 
	'I'+0x1D,'N'+0x1D,'S'+0x1D,'E'+0x1D,'R'+0x1D,'T'+0x1D,0x5D,'C'+0x1D,'A'+0x1D,'R'+0x1D,'D'+0x1D,'S'+0x1D, 
	'I'+0x1D,'N'+0x1D,'T'+0x1D,'O'+0x1D,0x5D,'E'+0x1D,'X'+0x1D,'O'+0x1D,'D'+0x1D,'U'+0x1D,'S'+0x1D,0x82, 
	0x5D,'S'+0x1D,'E'+0x1D,'A'+0x1D,'R'+0x1D,'C'+0x1D,'H'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D, 
	0x5D,0x5D,'S'+0x1D,'H'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'E'+0x1D,'S'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'D'+0x1D,'E'+0x1D,'A'+0x1D,'T'+0x1D,'H'+0x1D,0x5D,'B'+0x1D,'E'+0x1D,'L'+0x1D,'O'+0x1D,'W'+0x1D,0x82, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'D'+0x1D,'O'+0x1D,'N'+0x1D,0x86,'T'+0x1D,0x5D,'D'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'K'+0x1D,0x82, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'D'+0x1D,'O'+0x1D,'N'+0x1D,0x86,'T'+0x1D,0x5D,'D'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'K'+0x1D,0x82, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	0x5D,'G'+0x1D,'R'+0x1D,'E'+0x1D,'M'+0x1D,'L'+0x1D,'I'+0x1D,'N'+0x1D,'S'+0x1D,0x82,0x5D,0x5D, 
	0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
	'W'+0x1D,'I'+0x1D,'N'+0x1D,'D'+0x1D,'Y'+0x1D,0x5D,'G'+0x1D,'O'+0x1D,'L'+0x1D,'D'+0x1D,0x82,0x5D
};

unsigned char darkdat[] = {
	'I'+0x1D,'T'+0x1D,0x86,'S'+0x1D,0x5D,'D'+0x1D,'A'+0x1D,'R'+0x1D,'K'+0x1D,0x82,0x5d,0x5d
};

unsigned char bigleftmap[] = {
	0xEE,0xEC,
	0xED,0xEE,
	0xED,0xED,
	0xED,0xED,
	0xED,0xED,
	0xED,0xED,
	0xED,0xEF,
	0xEF,0xEC
};


unsigned char medleftmap[] = {
	0xED,0xED,0xF0,
	0xED,0xED,0xF6,
	0xED,0xED,0xF6,
	0xED,0xED,0xF1
};

unsigned char medrightmap[] = {
	0xF2,0xED,0xED,
	0xF7,0xED,0xED,
	0xF7,0xED,0xED,
	0xF3,0xED,0xED
};

unsigned char bigrightmap[] = {
	0xEC,0xF4,
	0xF4,0xED,
	0xED,0xED,
	0xED,0xED,
	0xED,0xED,
	0xED,0xED,
	0xF5,0xED,
	0xEC,0xF5
} ;


void formatnumber9(UWORD num,UBYTE length)
{
	UBYTE n ;
	unsigned char ch ;
	UWORD tens ;

	tens =1 ;

	for ( n=0 ; n<length-1 ; n++ )
		tens = tens*10 ;

	for ( n=0 ; n<length ; n++ )
	{
		ch=0x78U ; //'0'
		while ( num>= tens )
		{
			num -= tens ;
			ch++ ;
		}
		tens = tens/10 ;
		*((unsigned char*)screenbuf3+(UWORD)n) = ch ;


	}

}


UBYTE choosechar6()
{
	UBYTE p, keys, currchar, q ;


	memset(screenbuf3,0x04,7L) ;
	memset(screenbuf3+7L,0x00,7L) ;
	VBK_REG=1 ;
	for ( p=0 ; p<4 ; p++ )
		set_bkg_tiles2(13,p+1,7,1,screenbuf3) ;
	VBK_REG=0 ;

	currchar=0 ;
	q=0 ;

	waitpadup() ;
	while ( 1 )
	{
		q++ ;
		if ( q>240 )
		{
			if ( mode8tiles==7 )
				mode8tiles=0 ;
			else
				mode8tiles++ ;
			if ( mode4tiles==3 )
				mode4tiles=0 ;
			else
				mode4tiles++ ;
			q=0 ;
		}

		set_bkg_data2(  0x00, 0x01, u3tiles+(UWORD)((UWORD)mode4tiles<<4) );
		set_bkg_data2(  0x2A, 0x01, u3tiles+(UWORD)(((UWORD)(mode8tiles)+0x2AL)<<4) );


		keys = joypad() ;
		if ( keys&J_UP )
		{
			VBK_REG=1 ;    
			for ( p=0 ; p<4 ; p++ )
				set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3+7L) ;
			if ( currchar==0 )
				currchar = numplayers-1 ;
			else
				currchar-- ;
			for ( p=0 ; p<4 ; p++ )
				set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3) ;
			VBK_REG=0 ;    
			waitpadup() ;

		}
		if ( keys&J_DOWN )
		{
			VBK_REG=1 ;    
			for ( p=0 ; p<4 ; p++ )
				set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3+7L) ;
			if ( currchar==numplayers-1 )
				currchar = 0 ;
			else
				currchar++ ;
			for ( p=0 ; p<4 ; p++ )
				set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3) ;
			VBK_REG=0 ;    
			waitpadup() ;


		}
		if ( keys&J_A )
		{
			waitpadup() ;      
			keys=1 ;
			break ;
		}
		if ( keys&J_B )
		{
			keys=0 ;
			waitpadup() ;      
			break ;
		}



	}      

	set_bkg_data2(  0x26, 0x01, dung26 );
	set_bkg_data2(  0x32, 0x01, dung32 );
	set_bkg_data2(  0x2a, 0x01, dung2a );
	VBK_REG=1 ;
	for ( p=0 ; p<4 ; p++ )
		set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3+7L) ;
	VBK_REG=0 ;

	if ( keys==0 )
		currchar=99 ;

	return currchar ;
} 

void flashchar(UBYTE pnum, UBYTE sfx)
{
	UBYTE q ;

	memset(screenbuf3,0x04,7L) ;
	disable_interrupts2();
	VBK_REG = 1 ;
	for ( q=0 ; q<4 ; q++ )
		set_bkg_tiles2(13,q+(pnum<<2)+1,7,1,(unsigned char*)screenbuf3) ;
	VBK_REG = 0 ;
	enable_interrupts2() ;
	playerhitsfx(170U) ;
//	delay(1250) ;
	disable_interrupts2();
	VBK_REG = 1 ;
	memset(screenbuf3,0x00,7L) ;
	for ( q=0 ; q<4 ; q++ )
		set_bkg_tiles2(13,q+(pnum<<2)+1,7,1,(unsigned char*)screenbuf3) ;
	VBK_REG = 0 ;
	enable_interrupts2();


}

void cannonfire()
{
	UBYTE n ;
	UBYTE damage ;
	UBYTE damage2 ;

	for ( n=0 ; n!=4 ; n++ )
	{
		if ( (players[n].inparty)&&(players[n].status<2) )
		{
			damage = (make_rnd(dunglevel+1))<<3 ;
			damage = ((damage>>4)*10) + (damage&0x0F) ;
			damage2 = (make_rnd(0)) & 0x77 ;
			damage2 = ((damage2>>4)*10) + (damage2&0x0F) ;
			damage += damage2 ;
			if ( damage < players[n].currHP )
				players[n].currHP -= damage ;
			else
			{
				players[n].currHP = 0L ;
				players[n].status = 2;
				numalive-- ;
				screenbuf3[0] = 'D'+0x1D ;
				set_data2((unsigned char*)0x9800+19L+(32L*(2+(n<<2))),screenbuf3,1L) ;
				set_data2((unsigned char*)0x9C00+19L+(32L*(2+(n<<2))),screenbuf3,1L) ;

			}
			formatnumber9( (UWORD)(players[n].currHP),4) ;
			set_data2((unsigned char*)0x9800+14L+(32L*(2+(n<<2))),(unsigned char*)screenbuf3,4L) ;
			set_data2((unsigned char*)0x9C00+14L+(32L*(2+(n<<2))),(unsigned char*)screenbuf3,4L) ;
			flashchar(n,0) ;


		}


	}


}

UBYTE testplayerdex(UBYTE pnum)
{
	UBYTE playerdex ;

	playerdex = players[pnum].dex ;

	if ( (players[pnum].inparty==0)||(players[pnum].status>1) )
		return 0 ;

	if ( players[pnum].skill==9 ) //thief
		playerdex += 0x80U;
	else
		if ( (players[pnum].skill==0) || 
			 (players[pnum].skill==1) || 
			 (players[pnum].skill==5) || 
			 (players[pnum].skill==8) )
		playerdex += 0x40 ;

	if ( make_rnd(0) < playerdex )
		return 1;

	return 0 ;


}

void update_screen_dungeon()
{
	UBYTE n, iterx, itery, mask ;
	UBYTE smallmap ;
	UBYTE dungarray[12] ;
	UBYTE r,q ;
	unsigned char chestmap[2] ;
	unsigned char doormap[14] ;
	//UBYTE medleft, medfront, medright ;
	//UBYTE bigleft, bigfront, bigright ;
	unsigned char metile[11];

	UBYTE ux,uy ;



	if ( LCDC_REG&0x08 )
	{
		vidbase = (unsigned char*)0x9800 ;
		set_data2((unsigned char*)0x9800,(unsigned char*)0x9C00,0x400UL) ;
	}
	else
	{
		vidbase = (unsigned char*)0x9C00 ;
		set_data2((unsigned char*)0x9C00,(unsigned char*)0x9800,0x400UL) ;
	}


	set_bkg_data2(  0x26, 0x01, dung26 );
	set_bkg_data2(  0x32, 0x01, dung32 );
	set_bkg_data2(  0x2a, 0x01, dung2a );

	memset(metile,(unsigned char)0xD4,11L) ;
	//metile[10] = 0x3A ;

	for ( n=0 ; n!=11 ;n++ )
	{
		set_data2(vidbase+(32L*(UWORD)(n+1))+1L,metile,11L) ;

	}
	//memset(metile,(unsigned char)0x3A,11L) ;
	//set_data2(vidbase+(32L*11L)+1L,metile,11L) ;

	VBK_REG=0x01 ;
	memset(metile,(unsigned char)0x02,11L) ;
	for ( n=0 ; n!=11 ;n++ )
	{
		set_data2(vidbase+(32L*(UWORD)(n+1))+1L,metile,11L) ;

	}
	VBK_REG=0x00 ;

	metile[0] = 0x5D ;

	if ( dungdir==0 )
	{
		metile[0] = 0xA4U ;
		metile[1] = 0xA5U ;
		metile[2] = 0xA6U ;
	}
	else
		if ( dungdir==1 )
	{
		metile[1] = 0xA2U ;
		metile[2] = 0xA3U ;
	}
	else
		if ( dungdir==2 )
	{
		metile[0] = 0xA7U ;
		metile[1] = 0xA8U ;
		metile[2] = 0xA9U ;
	}
	else
	{
		metile[1] = 0xA0U ;
		metile[2] = 0xA1U ;
	}



	set_data2(vidbase+(32L*12L)+6L,metile,3L) ;

	metile[0]=0x94U ;
	set_data2(vidbase+33L,metile,1L) ;
	metile[0]=0x9AU ;
	set_data2(vidbase+42L,metile,1L) ;
	metile[0]=0x99U;
	set_data2(vidbase+321L,metile,1L) ;
	metile[0]=0x9BU;
	set_data2(vidbase+330L,metile,1L) ;
	metile[0] = 0x95U ;
	for ( n=0 ; n!=8 ; n++ )
	{
		set_data2(vidbase+32L+(UWORD)n+2L,metile,1L) ;
		set_data2(vidbase+320L+(UWORD)n+2L,metile,1L) ;
	}
	metile[0] = 0x97U ;
	for ( n=0 ; n!=8 ; n++ )
	{
		set_data2(vidbase+(32L*(UWORD)(n+2))+1L,metile,1L) ;
		set_data2(vidbase+(32L*(UWORD)(n+2))+10L,metile,1L) ;
	}

	for ( n=9; n!=38 ; n++ )
	{
		if ( (n>17) && (n&0x01) )
			set_sprite_prop(n,0x06|S_FLIPY) ;
		else
			set_sprite_prop(n,0x06)	;
		move_sprite(n,0,0) ;
	}
	//changeme - ladder tiles
	set_sprite_tile(9,0xFA) ;
	set_sprite_tile(10,0xFA) ;
	set_sprite_tile(11,0xFA) ;
	set_sprite_tile(12,0x4D) ;
	set_sprite_tile(13,0x4D) ;
	set_sprite_tile(14,0x4D) ;
	set_sprite_tile(15,0x4E) ;
	set_sprite_tile(16,0x4E) ;
	set_sprite_tile(17,0x4E) ;
	for ( n=0 ; n != 6 ; n++ )
		set_sprite_tile(n+30,0x4F) ;
	for ( n=0 ; n != 12 ; n++ )
		set_sprite_tile(n+18,0x50) ;
	set_sprite_tile(36,0x51) ;
	set_sprite_tile(37,0x51) ;

	if ( currdungtile==3 ) //strange winds
	{
		writegamemessage(strangewinddat) ;
		torchtime = 0 ;
	}
	if ( torchtime )
		torchtime-- ;
	else
	{
		writegamemessage(darkdat) ;
		if ( LCDC_REG&0x08 )
			LCDC_REG &= 0xF7 ;	//select $9800-$9BFF
		else
			LCDC_REG |= 0x08 ;	//select $9C00-$9FFF
		return ;
	}

	smallmap = 0 ;

	if ( dungdir==0 )
	{
		if ( dungy<3 )
			uy = 13+dungy;
		else
			uy =dungy-3 ;

		if ( dungx==0 )
			ux = 15;
		else
			ux =dungx-1;


		iterx = ux ;
		itery = uy ;

		for ( r=0 ; r != 4 ; r++ )
		{
			for ( q=0 ; q!=3 ; q++ )
			{
				dungarray[(r*3)+q]=*((unsigned char*)(0xA000+(((UWORD)dunglevel)*0x100L)+(UWORD)(itery<<4U)+(UWORD)iterx));
				if ( iterx==15 )
					iterx=0 ;
				else
					iterx++	;
			}
			if ( itery==15 )
				itery=0 ;
			else
				itery++	;
			iterx=ux ;
		}
	}
	if ( dungdir==1 )
	{
		if ( dungx>12 )
			ux = dungx-13;
		else
			ux =dungx+3 ;

		if ( dungy==0 )
			uy = 15;
		else
			uy =dungy-1;


		iterx = ux ;
		itery = uy ;

		for ( r=0 ; r != 4 ; r++ )
		{
			for ( q=0 ; q!=3 ; q++ )
			{
				dungarray[(r*3)+q]=*((unsigned char*)(0xA000+(((UWORD)dunglevel)*0x100L)+(UWORD)(itery<<4U)+(UWORD)iterx));
				if ( itery==15 )
					itery=0 ;
				else
					itery++	;
			}
			if ( iterx==0 )
				iterx=15 ;
			else
				iterx--	;
			itery=uy ;
		}
	}
	if ( dungdir==2 )
	{
		if ( dungy>12 )
			uy = dungy-13;
		else
			uy =dungy+3 ;

		if ( dungx==15 )
			ux = 0;
		else
			ux =dungx+1;


		iterx = ux ;
		itery = uy ;

		for ( r=0 ; r != 4 ; r++ )
		{
			for ( q=0 ; q!=3 ; q++ )
			{
				dungarray[(r*3)+q]=*((unsigned char*)(0xA000+(((UWORD)dunglevel)*0x100L)+(UWORD)(itery<<4U)+(UWORD)iterx));
				if ( iterx==0 )
					iterx=15 ;
				else
					iterx--	;
			}
			if ( itery==0 )
				itery=15 ;
			else
				itery--	;
			iterx=ux ;
		}
	}
	if ( dungdir==3 )
	{
		if ( dungx<3 )
			ux = 13+dungx;
		else
			ux =dungx-3 ;

		if ( dungy==15 )
			uy = 0;
		else
			uy =dungy+1;


		iterx = ux ;
		itery = uy ;

		for ( r=0 ; r != 4 ; r++ )
		{
			for ( q=0 ; q!=3 ; q++ )
			{
				dungarray[(r*3)+q]=*((unsigned char*)(0xA000+(((UWORD)dunglevel)*0x100L)+(UWORD)(itery<<4U)+(UWORD)iterx));
				if ( itery==0 )
					itery=15 ;
				else
					itery--	;
			}
			if ( iterx==15 )
				iterx=0 ;
			else
				iterx++	;
			itery=uy ;
		}
	}

	//memcpy((unsigned char*)0xB000,dungarray,12L) ;

	for ( r=0 ; r!=2 ; r++ )
		for ( q=0 ; q!=3 ; q++ )
		{
			if ( dungarray[(r*3)+q]&0x80U )
				smallmap += (0x01<<(2-q))<<(r<<2) ;

		}



	set_data2(vidbase+(32L*5L)+3L,smallmapdat+(((UWORD)(smallmap&0x0F))*0x60L)+(((UWORD)((smallmap>>4)&0x0F))*0x06L),6L) ;
	set_data2(vidbase+(32L*6L)+3L,smallmapdat+(((UWORD)(smallmap&0x0F))*0x60L)+(((UWORD)((smallmap>>4)&0x0F))*0x06L)+48L,6L) ;

	memset(metile,0xD6U,10L) ;

	chestmap[0] = 0xF8U ;
	chestmap[1] = 0xF9U ;


	if ( (dungarray[1]&0x30) && (!(dungarray[1]&0x80U)) )
	{
		if ( !( (dungarray[7]&0x80U) || (dungarray[4]&0x80U) || 
				(dungarray[10]&0x80U)  ) )
		{
			if ( dungarray[1]&0x10 )
				move_sprite(36,52,60) ;
			if ( dungarray[1]&0x20 )
				move_sprite(37,52,59) ;
		}
	}

	if ( (dungarray[3]&0x30) && (!(dungarray[3]&0x80U)) )
	{
		if ( !( (dungarray[7]&0x80U) || (dungarray[6]&0x80U) ||
				(dungarray[10]&0x80U)  ) )
		{
			if ( dungarray[3]&0x10 )
				move_sprite(18,40,55) ;
			if ( dungarray[3]&0x20 )
				move_sprite(19,40,65) ;
		}
	}
	if ( (dungarray[5]&0x30)  && (!(dungarray[5]&0x80U)) )
	{
		if ( !( (dungarray[7]&0x80U) || (dungarray[8]&0x80U) ||
				(dungarray[10]&0x80U)  ) )
		{
			if ( dungarray[5]&0x10 )
				move_sprite(22,65,55) ;
			if ( dungarray[5]&0x20 )
				move_sprite(23,65,65) ;
		}
	}
	if ( (dungarray[4]&0x30)  && (!(dungarray[4]&0x80U)) )
	{
		if ( !( (dungarray[7]&0x80U) || 
				(dungarray[10]&0x80U)  ) )
		{
			if ( dungarray[4]&0x10 )
				move_sprite(20,52,55) ;
			if ( dungarray[4]&0x20 )
				move_sprite(21,52,65) ;
		}
	}

	if ( (dungarray[6]&0x30)  && (!(dungarray[6]&0x80U)) )
	{
		if ( !( (dungarray[9]&0x80U) || 
				(dungarray[10]&0x80U)  ) )
		{
			if ( dungarray[6]&0x10 )
				move_sprite(24,30,48) ;
			if ( dungarray[6]&0x20 )
				move_sprite(25,30,72) ;
		}
	}
	if ( (dungarray[8]&0x30)  && (!(dungarray[8]&0x80U)) )
	{
		if ( !( (dungarray[11]&0x80U) || 
				(dungarray[10]&0x80U)  ) )
		{
			if ( dungarray[8]&0x10 )
				move_sprite(26,75,48) ;
			if ( dungarray[8]&0x20 )
				move_sprite(27,75,72) ;
		}
	}
	if ( (dungarray[7]&0x30)  && (!(dungarray[7]&0x80U)) )
	{
		if ( !( (dungarray[10]&0x80U)  ) )
		{
			if ( dungarray[7]&0x10 )
				move_sprite(28,52,48) ;
			if ( dungarray[7]&0x20 )
				move_sprite(29,52,72) ;
		}
	}
	if ( (dungarray[9]&0x10)  && (!(dungarray[9]&0x80U)) && (!(dungarray[10]&0x80U)) )
		move_sprite(30,24,40) ;
	if ( (dungarray[9]&0x20)  && (!(dungarray[9]&0x80U)) && (!(dungarray[10]&0x80U)) )
		move_sprite(31,24,80) ;
	if ( (dungarray[11]&0x10) && (!(dungarray[11]&0x80U)) && (!(dungarray[10]&0x80U)) )
		move_sprite(34,80,40) ;
	if ( (dungarray[11]&0x20) && (!(dungarray[11]&0x80U)) && (!(dungarray[10]&0x80U)) )
		move_sprite(35,80,80) ;
	if ( (dungarray[10]&0x10) && (!(dungarray[10]&0x80U)) )
		move_sprite(32,52,32) ;
	if ( (dungarray[10]&0x20) && (!(dungarray[10]&0x80U)) )
		move_sprite(33,52,88) ;

	if ( dungarray[0]==0xC0 )
	{
		if ( !( (dungarray[3]&0x80U) || (dungarray[6]&0x80U) ||
				(dungarray[4]&0x80U) || (dungarray[7]&0x80U) || 
				(dungarray[10]&0x80U)  ) )
			move_sprite(15,42,61) ;

	}
	if ( dungarray[2]==0xC0 )
	{
		if ( !( (dungarray[5]&0x80U) || (dungarray[8]&0x80U) ||
				(dungarray[4]&0x80U) || (dungarray[7]&0x80U) || 
				(dungarray[10]&0x80U)  ) )
			move_sprite(16,62,61) ;

	}
	if ( dungarray[1]==0xC0 )
	{
		if ( !( (dungarray[4]&0x80U) || (dungarray[7]&0x80U) ||
				(dungarray[10]&0x80U)  ) )
			move_sprite(17,52,61) ;

	}

	if ( dungarray[3]==0x40 )
	{
		if ( !((dungarray[6]&0x80U) || (dungarray[7]&0x80U) || (dungarray[10]&0x80U)) )
			move_sprite(9,40,66) ;
	}
	if ( dungarray[4]==0x40 )
	{
		if ( !((dungarray[10]&0x80U) || (dungarray[7]&0x80U)) )
			move_sprite(10,52,66) ;
	}
	if ( dungarray[5]==0x40 )
	{
		if ( !((dungarray[8]&0x80U) || (dungarray[7]&0x80U) || (dungarray[10]&0x80U)) )
			move_sprite(11,64,66) ;
	}

	//changeme - doormap
	for ( n=0 ; n != 4 ; n++ )
		doormap[n] = n + 0x49;

	if ( dungarray[3]==0xC0 )
	{
		if ( !( (dungarray[4]&0x80U) || (dungarray[7]&0x80U) || (dungarray[10]&0x80U) ) )
			move_sprite(12,46,62) ;

		set_data2(vidbase+(32L*5L)+3L,doormap,2L) ;
		set_data2(vidbase+(32L*6L)+3L,doormap+2L,2L) ;

	}
	if ( dungarray[5]==0xC0 )
	{
		if ( !( (dungarray[4]&0x80U) || (dungarray[7]&0x80U) || (dungarray[10]&0x80U) ) )
			move_sprite(12,57,62) ;

		set_data2(vidbase+(32L*5L)+7L,doormap,2L) ;
		set_data2(vidbase+(32L*6L)+7L,doormap+2L,2L) ;

	}
	if ( dungarray[4]==0xC0 )
	{
		set_data2(vidbase+(32L*5L)+5L,doormap,2L) ;
		set_data2(vidbase+(32L*6L)+5L,doormap+2L,2L) ;
	}

	for ( n=6 ; n!=9 ; n++ )
	{
		if ( dungarray[n]==0x40 )
			set_data2(vidbase+(32L*7L)+(UWORD)((n-6)*2)+3L,chestmap,2L) ;


	}
	chestmap[0] = 0x3AU ;
	chestmap[1] = 0x3AU ;

	if ( dungarray[6]&0x80U )
	{
		for ( n=0 ; n!=4 ; n++ )
			set_data2(vidbase+(32L*(UWORD)(4+n))+2L,medleftmap+(UWORD)(n*3),3L) ;

	}
	if ( dungarray[8]&0x80U )
	{
		for ( n=0 ; n!=4 ; n++ )
			set_data2(vidbase+(32L*(UWORD)(4+n))+7L,medrightmap+(UWORD)(n*3),3L) ;
	}
	doormap[1] = 0x3A ;
	if ( dungarray[6]==0xC0 )
		for ( n=0 ; n!=3 ; n++ )
		{
			doormap[0] = 0x26+n ;
			set_data2(vidbase+(32L*(UWORD)(5+n))+4L,doormap,1L) ;
			set_data2(vidbase+(32L*(UWORD)(5+n))+2L,doormap+1L,1L) ;
		}
	if ( dungarray[8]==0xC0 )
		for ( n=0 ; n!=3 ; n++ )
		{
			doormap[0] = 0x29+n ;
			set_data2(vidbase+(32L*(UWORD)(5+n))+7L,doormap,1L) ;
			set_data2(vidbase+(32L*(UWORD)(5+n))+9L,doormap+1L,1L) ;
		}


	if ( dungarray[7]&0x80U )
	{
		for ( n=0 ; n!=4 ; n++ )
			set_data2(vidbase+(32L*(UWORD)(4+n))+4L,metile,4L) ;

	}

	doormap[0] = 0x3A ;
	if ( dungarray[7]==0xC0 )
		for ( n=0 ; n!=3 ; n++ )
			set_data2(vidbase+(32L*(UWORD)(5+n))+5L,doormap,2L) ;




	if ( dungarray[9]==0x40 )
		set_data2(vidbase+(32L*9L)+2L,chestmap,1L) ;
	if ( dungarray[10]==0x40 )
		set_data2(vidbase+(32L*9L)+5L,chestmap,2L) ;
	if ( dungarray[11]==0x40 )
		set_data2(vidbase+(32L*9L)+9L,chestmap,1L) ;


	if ( dungarray[9]&0x80U )
	{
		for ( n=0 ; n!=8 ; n++ )
			set_data2(vidbase+(32L*(UWORD)(2+n))+2L,bigleftmap+(UWORD)(n*2),2L) ;

	}
	if ( dungarray[11]&0x80U )
	{
		for ( n=0 ; n!=8 ; n++ )
			set_data2(vidbase+(32L*(UWORD)(2+n))+8L,bigrightmap+(UWORD)(n*2),2L) ;
	}

	if ( dungarray[9]==0xC0 )
		for ( n=0 ; n!=7 ; n++ )
		{
			//changeme
			doormap[0] = 0x2C+(2*n) ;
			doormap[1] = 0x2D+(2*n) ;
			set_data2(vidbase+(32L*(UWORD)(3+n))+2L,doormap,2L) ;
		}
	if ( dungarray[11]==0xC0 )
		for ( n=0 ; n!=7 ; n++ )
		{
			//changeme
			doormap[0] = 0x3B+(2*n) ;
			doormap[1] = 0x3C+(2*n) ;
			set_data2(vidbase+(32L*(UWORD)(3+n))+8L,doormap,2L) ;
		}

	if ( (dungarray[10]==0x80U)||(dungarray[10]==0xA0U) )
	{
		for ( n=0 ; n!=8 ; n++ )
			set_data2(vidbase+(32L*(UWORD)(2+n))+2L,metile,8L) ;

	}
	memset(doormap,0xD6U,8L) ;//changeme

	if ( dungarray[10]==0xC0 )
	{
		set_data2(vidbase+(32L*2L)+2L,doormap,8L) ;
		set_data2(vidbase+(32L*3L)+2L,doormap,8L) ;
		for ( n=0 ; n!=6 ; n++ )
		{
			set_data2(vidbase+(32L*(UWORD)(4+n))+2L,doormap,2L) ;
			set_data2(vidbase+(32L*(UWORD)(4+n))+8L,doormap,2L) ;
		}
	}

	if ( LCDC_REG&0x08 )
		LCDC_REG &= 0xF7 ;	//select $9800-$9BFF
	else
		LCDC_REG |= 0x08 ;	//select $9C00-$9FFF

	if ( currdungtile==8 ) //misty writing
	{
		writegamemessage(mistydat) ;
		writegamemessage(dungtextdat+((UWORD)dungnumber*192UL)+((UWORD)dunglevel*24L)) ;
		writegamemessage(dungtextdat+((UWORD)dungnumber*192UL)+((UWORD)dunglevel*24L)+12L) ;

	}
	else
		if ( currdungtile==6 ) //gremlins
	{
		writegamemessage(gremlinsdat) ;
		attackmisssfx(120U) ;

		while ( !(players[(n= (make_rnd(4)))].inparty) )
			;
		if ( players[n].food <= 100L )
			players[n].food = 0L ;
		else
			players[n].food	-= 100L ;
		*((unsigned char*)(0xA000+(((UWORD)dunglevel)*0x100L)+(UWORD)(dungy<<4U)+(UWORD)dungx)) = 0x00 ;
		currdungtile = 0 ;
		dungrefresh=2 ;

	}
	else
		if ( currdungtile==4 ) //trap
	{
		*((unsigned char*)(0xA000+(((UWORD)dunglevel)*0x100L)+(UWORD)(dungy<<4U)+(UWORD)dungx)) = 0x00 ;
		currdungtile = 0 ;
		writegamemessage(trapdat) ;
		if ( testplayerdex(0) )
		{

			dungrefresh = 2 ;
			cannonfire() ;
			/*
		   for (q = 0 ; q!=4 ; q++)
		   {
			   if ((!(players[q].inparty))||(players[q].status>1))
				   continue ;

			  //trapeffect(q) ;
			  r = (UBYTE)  (((((UWORD)arand()&0x00FF)*25UL)/255UL)) ;
			  if (r<10)
				 r += 5 ;
			  if ( (UWORD)r < players[q].currHP)
				 players[q].currHP -= (UWORD)r ;
			  else
			  {
				 players[q].currHP = 0L ;
				 players[q].status = 0x02 ;
				 numalive-- ;
				 writegamemessage(deaddat5) ;
			
			  }
		   }
			  */
		}
		else
		{
			writegamemessage(trapevadeddat) ;
			attackmisssfx(120U) ;

		}


	}
	else
		if ( currdungtile==2 ) //fountain
	{
		changemusic = 3 ;
		if ( LCDC_REG&0x08 )
			set_data2((unsigned char*)0x9800,(unsigned char*)0x9C00,0x400L) ;
		else
			set_data2((unsigned char*)0x9C00,(unsigned char*)0x9800,0x400L)	;

		set_bkg_tiles2(1,1,11,11,fountainmap) ;
		memset(metile,0x01,11L) ;
		VBK_REG=1 ;
		for ( r=0 ; r!=11 ; r++ )
			set_bkg_tiles2(1,1+r,11,1,metile) ;
		VBK_REG=0 ;

		writegamemessage(fountaindat1) ;
		writegamemessage(fountaindat2) ;
		r = choosechar6() ;
		if ( r!=99 )
		{
			if ( players[r].status<2 )
			{
				if ( (dungx&0x03)==0 ) //poison
				{
					writegamemessage(fountres2) ;
					if ( players[r].status==0 )
						players[r].status = 1 ;
					flashchar(r,0) ;

				}
				else
					if ( (dungx&0x03)==1 ) //health max
				{
					writegamemessage(fountres1) ;
					players[r].currHP = players[r].maxHP ;

				}
				else
					if ( (dungx&0x03)==2 ) //25 damage
				{

					writegamemessage(fountres4) ;
					flashchar(r,0) ;
					if ( players[r].currHP<26L )
					{
						players[r].currHP = 0L ;
						players[r].status = 2 ;
						numalive-- ;
						writegamemessage(deaddat5) ;
					}
					else
						players[r].currHP -= 25L ;
				}
				else
					if ( (dungx&0x03)==3 ) //cure poison
				{
					writegamemessage(fountres3) ;
					if ( players[r].status==1 )
						players[r].status = 0 ;

				}

			}
			else
			{
				writegamemessage(cantdat) ;
				attackmisssfx(120U) ;
			}



		}
		memset(metile,0x02,11L) ;
		VBK_REG=1 ;
		for ( r=0 ; r!=11 ; r++ )
			set_bkg_tiles2(1,1+r,11,1,metile) ;
		VBK_REG=0 ;
		if ( LCDC_REG&0x08 )
			set_data2((unsigned char*)0x9C00,(unsigned char*)0x9800,12L*32L) ;
		else
			set_data2((unsigned char*)0x9800,(unsigned char*)0x9C00,12L*32L) ;
		dungrefresh = 2 ;
		changemusic = 6 ;

	}
	else
		if ( currdungtile==5 ) //mark
	{
		changemusic = 3 ;
		if ( LCDC_REG&0x08 )
			set_data2((unsigned char*)0x9800,(unsigned char*)0x9C00,0x400L) ;
		else
			set_data2((unsigned char*)0x9C00,(unsigned char*)0x9800,0x400L)	;
		set_bkg_data2(  0x2A, 0x01, u3tiles+(UWORD)(((UWORD)(mode8tiles)+0x2AL)<<4) );

		memset(metile,0x5d,11L);
		for ( r=0 ; r!=2 ; r++ )
		{
			set_bkg_tiles2(1,1+r,11,1,metile) ;
			set_bkg_tiles2(1,10+r,11,1,metile) ;
		}
		memset(metile,0x3a,11L);
		for ( r=0 ; r!=7 ; r++ )
			set_bkg_tiles2(1,3+r,11,1,metile) ;
		metile[0] = 0x2a ;
		set_bkg_tiles2(6,6,1,1,metile) ;
		metile[0] = 0x00 ;
		VBK_REG=1 ;
		set_bkg_tiles2(6,6,1,1,metile) ;
		VBK_REG=0 ;

		writegamemessage(markdat1) ;
		writegamemessage(markdat2) ;
		writegamemessage(markdat3) ;
		writegamemessage(markdat4) ;
		r = choosechar6() ;
		if ( r!=99 )
		{
			if ( players[r].status<2 )
			{
				if ( players[r].currHP <=50L )
				{
					writegamemessage(killeddat2) ;
					players[r].currHP = 0L ;
					players[r].status = 2 ;
					numalive-- ;
				}
				else
				{
					writegamemessage(leftmarkdat) ;
					if ( (dungx&0x03)==0 ) //force
						players[r].markcard |= 0x10 ;
					if ( (dungx&0x03)==1 ) //fire
						players[r].markcard |= 0x20 ;
					if ( (dungx&0x03)==2 ) //snake
						players[r].markcard |= 0x40 ;
					if ( (dungx&0x03)==3 ) //kings
						players[r].markcard |= 0x80U ;
					players[r].currHP -= 50L ;

				}
				flashchar(r,0) ;

			}
			else
			{
				writegamemessage(cantdat) ;
			}

		}
		metile[0] = 0x02 ;
		VBK_REG=1 ;
		set_bkg_tiles2(6,6,1,1,metile) ;
		VBK_REG=0 ;
		if ( LCDC_REG&0x08 )
			set_data2((unsigned char*)0x9C00,(unsigned char*)0x9800,12L*32L) ;
		else
			set_data2((unsigned char*)0x9800,(unsigned char*)0x9C00,12L*32L) ;
		dungrefresh = 2 ;

		changemusic = 6 ;

	}
	else
		if ( currdungtile==1 )	//time lord
	{
		changemusic = 3 ;
		if ( LCDC_REG&0x08 )
			set_data2((unsigned char*)0x9800,(unsigned char*)0x9C00,0x400L) ;
		else
			set_data2((unsigned char*)0x9C00,(unsigned char*)0x9800,0x400L)	;
		set_bkg_data2(  0x26, 0x01, u3tiles+(UWORD)(((UWORD)(mode4tiles)+0x26L)<<4) );
		set_bkg_data2(  0x32, 0x01, u3tiles+(UWORD)(((UWORD)(mode8tiles)+0x32L)<<4) );

		set_bkg_tiles2(1,1,11,11,timelordmap) ;
		memset(metile,0x03,11L);
		VBK_REG=1 ;
		for ( r=0 ; r!=11 ;r++ )
		{
			set_bkg_tiles2(1,1+r,11,1,metile) ;
		}
		metile[0] = 1 ;
		set_bkg_tiles2(6,8,1,1,metile) ;
		VBK_REG=0 ;

		writegamemessage(timedat1) ;
		writegamemessage(timedat2) ;
		writegamemessage(timedat3) ;
		waitpadup() ;
		q=0 ;
		while ( 1 )
		{
			q++ ;
			if ( q>240 )
			{
				if ( mode8tiles==7 )
					mode8tiles=0 ;
				else
					mode8tiles++ ;
				if ( mode4tiles==3 )
					mode4tiles=0 ;
				else
					mode4tiles++ ;
				q=0 ;
			}
			set_bkg_data2(  0x26, 0x01, u3tiles+(UWORD)(((UWORD)(mode4tiles)+0x26L)<<4) );
			set_bkg_data2(  0x32, 0x01, u3tiles+(UWORD)(((UWORD)(mode8tiles)+0x32L)<<4) );
			if ( joypad() )
				break ;
		}
		writegamemessage(timedat4) ;
		writegamemessage(timedat5) ;
		writegamemessage(timedat6) ;
		writegamemessage(timedat7) ;
		waitpadup() ;
		while ( 1 )
		{
			q++ ;
			if ( q>240 )
			{
				if ( mode8tiles==7 )
					mode8tiles=0 ;
				else
					mode8tiles++ ;
				if ( mode4tiles==3 )
					mode4tiles=0 ;
				else
					mode4tiles++ ;
				q=0 ;
			}
			set_bkg_data2(  0x26, 0x01, u3tiles+(UWORD)(((UWORD)(mode4tiles)+0x26L)<<4) );
			set_bkg_data2(  0x32, 0x01, u3tiles+(UWORD)(((UWORD)(mode8tiles)+0x32L)<<4) );
			if ( joypad() )
				break ;
		}
		waitpadup() ;

		memset(metile,0x02,11L);
		VBK_REG=1 ;
		for ( r=0 ; r!=11 ;r++ )
		{
			set_bkg_tiles2(1,1+r,11,1,metile) ;
		}
		VBK_REG=0 ;


		if ( LCDC_REG&0x08 )
			set_data2((unsigned char*)0x9C00,(unsigned char*)0x9800,12L*32L) ;
		else
			set_data2((unsigned char*)0x9800,(unsigned char*)0x9C00,12L*32L) ;
		dungrefresh = 2 ;
		changemusic = 6 ;

	}


}

UBYTE isvaliddungmove(UBYTE move)
{
	UBYTE ux, uy ;
	UBYTE iterx, itery, realdir  ;
	unsigned char thetile ;

	if ( move==1 )	//turning
		return(!(*((unsigned char*)(0xA000+(((UWORD)dunglevel)*0x100L)+(UWORD)(dungy<<4U)+(UWORD)dungx))&0x80U)) ;

	realdir = dungdir ;
	if ( move==3 ) //move backward
	{
		if ( realdir>1 )
			realdir -=2 ;
		else
			realdir	+= 2 ;
	}

	ux = dungx ;
	uy = dungy ;

	if ( realdir==0 )
		if ( dungy==0 )
			uy=15 ;
		else
			uy = dungy-1 ;
	else
		if ( realdir==1 )
		if ( dungx==15 )
			ux = 0 ;
		else
			ux = dungx+1 ;
	else
		if ( realdir==2 )
		if ( dungy==15 )
			uy = 0 ;
		else
			uy = dungy+1 ;
	else
		if ( dungx==0 )
		ux=15 ;
	else
		ux = dungx-1 ;


	thetile = *((unsigned char*)(0xA000+(((UWORD)dunglevel)*0x100L)+(UWORD)(uy<<4U)+(UWORD)ux)) ;
	if ( thetile != 0x80U )
	{
		currdungtile = thetile ;
		dungx = ux ;
		dungy = uy ;
	}

	return(thetile!=0x80U) ;
}

