#include <gb.h>
#include "u3.h"

#define u3tiles ((unsigned char*)(0xB000))
#define tile_palettes ((unsigned char*)(0xB930))
#define tile_attribs  ((unsigned char*)(0xB990))
#define check_order ((unsigned char*)(0xB9F0))
#define bkg_p ((UWORD*)(0xBA40))
#define obj_p ((UWORD*)(0xBA80))
#define battlemaps ((UWORD*)(0xBAC0))

UBYTE yesnoglobal ;

extern UBYTE playerscreentile ;
extern UBYTE blinkdelay ;
extern UBYTE tileon ;
extern UBYTE currplayer ;
extern UBYTE peermap ;

extern UWORD party_specials ;

extern UBYTE changemusic ;
extern UBYTE extragame ;

extern UBYTE peer_semaphore ;

extern PLAYER players[] ;
extern MONSTER monsters[] ;
extern UBYTE nummonsters ;
extern UBYTE numplayers; 
extern UBYTE monsterattrib ;
extern UBYTE monsterpower ;

extern UBYTE playerx ;
extern UBYTE playery ;
extern UBYTE screenx ;
extern UBYTE screeny ;
extern UBYTE need_refresh ;
extern UBYTE inside ;
extern UBYTE transport ;

extern UBYTE numgoodies; 
extern UBYTE numalive ;

extern UBYTE stoptimebattle ;
extern UBYTE stoptime ;
extern UBYTE monstertile ;

extern unsigned char *vidbase ;

extern UBYTE delayscroll ;
extern UBYTE mode4tiles ;
extern UBYTE mode8tiles ;
extern unsigned char screenbuf3[] ;
extern UBYTE mapnum ;


unsigned char whodat35[] = {
	'W'+0x1D,'H'+0x1D,'O'+0x1D,0x83,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d
};

unsigned char gooddaydat35[] = {
	'G'+0x1D,'O'+0x1D,'O'+0x1D,'D'+0x1D,0x5D,'D'+0x1D,'A'+0x1D,'Y'+0x1D,0x82,0x5d,0x5d,0x5d
};

unsigned char notheredat35[] = {
	'N'+0x1D,'O'+0x1D,'T'+0x1D,0x5D,'H'+0x1D,'E'+0x1D,'R'+0x1D,'E'+0x1D,0x82,0x5D,0x5D,0x5D
} ;

unsigned char chardat35[] = {
	'H'+0x1D,'F'+0x1D,'M'+0x1D  
};
unsigned char charstat35[] = {
	'G'+0x1D,'P'+0x1D,'D'+0x1D,'A'+0x1D
};
unsigned char anddat35[] = {
	'A'+0x1D,'N'+0x1D,'D'+0x1D,
} ;

unsigned char golddat35[] = {
	'G'+0x1D,'O'+0x1D,'L'+0x1D,'D'+0x1D
} ;



unsigned char yesno35[] = {
	'N'+0x1D,'O'+0x1D,0x5d,0x5d,0x5d,0x5d,0x5d,
	'Y'+0x1D,'E'+0x1D,'S'+0x1D,0x5d,0x5d,0x5d,0x5d
};


void formatnumber35(UWORD num,UBYTE length)
{
	UBYTE n ;
	unsigned char ch ;
	UWORD tens ;

	tens =1 ;

	for ( n=0 ; n<length-1 ; n++ )
		tens = tens*10 ;

	for ( n=0 ; n<length ; n++ )
	{
		ch=0x78U ; //'0'
		while ( num>= tens )
		{
			num -= tens ;
			ch++ ;
		}
		tens = tens/10 ;
		*((unsigned char*)screenbuf3+(UWORD)n) = ch ;


	}

}

void charscreen35(PLAYER *player, UBYTE loc)
{
	UBYTE n ;

	memset(screenbuf3,0x5D,11L) ;

	for ( n=0 ; n<4 ; n++ )
		set_bkg_tiles2( 13, n+1+(loc<<2), 7, 1, (unsigned char*)screenbuf3 );

	if ( !(player->inparty) )
		return ;

	set_bkg_tiles2( 13, 2+(loc<<2), 1, 3, chardat35);

	set_bkg_tiles2( 13, 1+(loc<<2), 7, 1, player->name );
	formatnumber35(player->currHP,4) ;
	set_bkg_tiles2( 14, 2+(loc<<2), 4, 1, (unsigned char*)screenbuf3);

	set_bkg_tiles2( 19, 2+(loc<<2), 1, 1, charstat35+(UWORD)player->status );

	formatnumber35(player->food,4) ;
	set_bkg_tiles2( 14, 3+(loc<<2), 4, 1, (unsigned char*)screenbuf3 );

	formatnumber35(player->magic,2) ;
	set_bkg_tiles2( 14, 4+(loc<<2), 2, 1, (unsigned char*)screenbuf3 );

	formatnumber35(player->level,2) ;
	set_bkg_tiles2( 18, 4+(loc<<2), 2, 1, (unsigned char*)screenbuf3 );

	*(unsigned char*)screenbuf3 = 'L'+0x1D ;
	set_bkg_tiles2( 17, 4+(loc<<2), 1, 1, (unsigned char*)screenbuf3 );


}


UBYTE choosechar35()
{
	UBYTE p, keys, currchar ;


	writegamemessage(whodat35) ;

	for ( p=0; p<4 ; p++ )
		charscreen35(&(players[p]),p) ;

	memset(screenbuf3,0x04,7L) ;
	memset(screenbuf3+7L,0x00,7L) ;
	VBK_REG=1 ;
	for ( p=0 ; p<4 ; p++ )
		set_bkg_tiles2(13,p+1,7,1,screenbuf3) ;
	VBK_REG=0 ;

	currchar=0 ;

	waitpadup() ;
	while ( 1 )
	{
		keys = joypad() ;
		if ( keys&J_UP )
		{
			VBK_REG=1 ;    
			for ( p=0 ; p<4 ; p++ )
				set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3+7L) ;
			if ( currchar==0 )
				currchar = numplayers-1 ;
			else
				currchar-- ;
			for ( p=0 ; p<4 ; p++ )
				set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3) ;
			VBK_REG=0 ;    
			waitpadup() ;

		}
		if ( keys&J_DOWN )
		{
			VBK_REG=1 ;    
			for ( p=0 ; p<4 ; p++ )
				set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3+7L) ;
			if ( currchar==numplayers-1 )
				currchar = 0 ;
			else
				currchar++ ;
			for ( p=0 ; p<4 ; p++ )
				set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3) ;
			VBK_REG=0 ;    
			waitpadup() ;


		}
		if ( keys&J_A )
		{
			waitpadup() ;      
			keys=1 ;
			break ;
		}
		if ( keys&J_B )
		{
			keys=0 ;
			waitpadup() ;      
			break ;
		}



	}      

	VBK_REG=1 ;
	for ( p=0 ; p<4 ; p++ )
		set_bkg_tiles2(13,p+1+(currchar<<2),7,1,screenbuf3+7L) ;
	VBK_REG=0 ;

	if ( keys==0 )
		currchar=99 ;

	return currchar ;
} 


UWORD getamt35(UBYTE digits, UWORD maxamt)
{
	UWORD amt ;
	UBYTE currentdigit,p ;
	UBYTE digitvalue ;
	UBYTE joykeys ;
	UWORD multiplier ;
	unsigned char thedigit ;

	amt =0L ;
	multiplier = 1L ;
	currentdigit=0 ;
	digitvalue = 0 ;
	formatnumber35(amt,4) ;
	set_bkg_tiles2(4,17,4,1,screenbuf3) ;
	memset(screenbuf3,0x04,4L) ;
	VBK_REG=1 ;
	set_bkg_tiles2(7,17,1,1,screenbuf3) ;
	VBK_REG=0 ;

	waitpadup() ;
	while ( 1 )
	{
		joykeys=joypad() ;
		if ( joykeys&J_UP )
		{
			if ( digitvalue<9 )
			{
				if ( amt + multiplier <= maxamt )
				{
					digitvalue++ ;
					amt += multiplier ;
					formatnumber35(amt,4) ;
					set_bkg_tiles2(4,17,4,1,screenbuf3) ;
				}


			}

			waitpadup() ;
		}
		if ( joykeys&J_DOWN )
		{
			if ( digitvalue )
			{
				digitvalue-- ;
				amt -= multiplier ;
				formatnumber35(amt,4) ;
				set_bkg_tiles2(4,17,4,1,screenbuf3) ;

			}

			waitpadup() ;
		}

		if ( joykeys&J_RIGHT )
		{
			screenbuf3[0] = 0x04 ;
			screenbuf3[1] = 0x00 ;
			VBK_REG=1 ;
			set_bkg_tiles2(7-currentdigit,17,1,1,screenbuf3+1) ;
			VBK_REG=0 ;
			if ( currentdigit==0 )
			{
				currentdigit = digits-1 ;
				multiplier=1L ;
				for ( p=0 ; p<currentdigit ; p++ )
					multiplier *= 10L ;
			}
			else
			{
				currentdigit-- ;
				multiplier /= 10L ;
			}
			VBK_REG=1 ;
			set_bkg_tiles2(7-currentdigit,17,1,1,screenbuf3) ;
			VBK_REG=0 ;

		}
		if ( joykeys&J_LEFT )
		{
			screenbuf3[0] = 0x04 ;
			screenbuf3[1] = 0x00 ;
			VBK_REG=1 ;
			set_bkg_tiles2(7-currentdigit,17,1,1,screenbuf3+1) ;
			VBK_REG=0 ;
			if ( currentdigit==digits-1 )
			{
				currentdigit = 0 ;
				multiplier = 1L ;
			}
			else
			{
				currentdigit++ ;
				multiplier *= 10L ;
			}
			VBK_REG=1 ;
			set_bkg_tiles2(7-currentdigit,17,1,1,screenbuf3) ;
			VBK_REG=0 ;


		}
		if ( (joykeys&J_LEFT)||(joykeys&J_RIGHT) )
		{
			get_bkg_tiles2(7-currentdigit,17,1,1,&thedigit) ;
			digitvalue = thedigit-0x78U ;
			waitpadup() ;  
		}
		if ( (joykeys&J_B)||(joykeys&J_A) )
		{
			screenbuf3[1] = 0x00 ;
			VBK_REG=1 ;
			set_bkg_tiles2(7-currentdigit,17,1,1,screenbuf3+1) ;
			VBK_REG=0 ;
			waitpadup() ;
			if ( joykeys&J_B )
				return 0L ;
			else
				break ;
		}

	}

	return amt ;

}

UBYTE getmenuselection35(UBYTE numlines,unsigned char *menudata, void (*descptr)(UBYTE,unsigned char*),
						 unsigned char *descptrdat)
{
	UBYTE p ;
	UBYTE currline ;
	UBYTE keys ;

	if ( LCDC_REG&0x08 )   //select $9C00-$9FFF
		vidbase = (unsigned char*)0x9C00 ;
	else
		vidbase	= (unsigned char*)0x9800 ;

	memset(screenbuf3,0x5d,7L) ;
	memset(screenbuf3+7L,0x00,7L) ;
	for ( p=0 ; p<16;p++ )
	{
		set_data2(vidbase+(32L*((UWORD)(p)+1L))+13L,screenbuf3,7L); 
		VBK_REG=1 ;       
		set_data2(vidbase+(32L*((UWORD)(p)+1L))+13L,screenbuf3+7L,7L); 
		VBK_REG=0 ;       
	}

	for ( p=0 ; p<numlines ; p++ )
		set_data2(vidbase+(32L*((UWORD)(p)+1L))+13L,menudata+((UWORD)p*7L),7L); 

	currline = 0 ;
	memset(screenbuf3,0x04,7L) ;
	VBK_REG=1 ;      
	set_data2(vidbase+(32L*1L)+13L,screenbuf3,7L); 
	VBK_REG=0 ;      

	if ( descptr )
		descptr(currline,descptrdat) ;

	waitpadup() ;

	currline = 0 ;
	while ( 1 )
	{
		keys = joypad() ;
		if ( keys&J_UP )
		{
			VBK_REG=1 ;    
			set_data2(vidbase+(32L*((UWORD)currline+1L))+13L,screenbuf3+7L,7L); 
			if ( currline==0 )
				currline = numlines-1 ;
			else
				currline-- ;
			set_data2(vidbase+(32L*((UWORD)currline+1L))+13L,screenbuf3,7L); 
			VBK_REG=0 ;    
			if ( descptr )
				descptr(currline,descptrdat) ;
			waitpadup() ;

		}
		if ( keys&J_DOWN )
		{
			VBK_REG=1 ;    
			set_data2(vidbase+(32L*((UWORD)currline+1L))+13L,screenbuf3+7L,7L); 
			if ( currline==numlines-1 )
				currline = 0 ;
			else
				currline++ ;
			set_data2(vidbase+(32L*((UWORD)currline+1L))+13L,screenbuf3,7L); 
			VBK_REG=0 ;    
			if ( descptr )
				descptr(currline,descptrdat) ;
			waitpadup() ;


		}
		if ( keys&J_A )
		{
			waitpadup() ;      
			keys=1 ;
			break ;
		}
		if ( keys&J_B )
		{
			keys = 0 ;
			waitpadup() ;      
			break ;
		}

	}


	VBK_REG=1 ;      
	set_data2(vidbase+(32L*((UWORD)currline+1L))+13L,screenbuf3+7L,7L); 
	VBK_REG=0 ;      

	if ( keys==0 )
		return 99 ;

	return currline ;

}


void shopwadesc35(UBYTE currline, unsigned char *descptr)
{
	unsigned char screenbuf4[12] ;

	memset(screenbuf4,0x5D,12L) ;
	set_bkg_tiles2( 0, 13, 12, 1, (unsigned char*)screenbuf4);
	set_bkg_tiles2( 0, 16, 12, 1, (unsigned char*)screenbuf4);
	//set_bkg_tiles2( 0, 17, 12, 1, (unsigned char*)screenbuf4);

	set_bkg_tiles2(0,14,12,1,descptr+((UWORD)currline*24L)) ;
	set_bkg_tiles2(0,15,12,1,descptr+((UWORD)currline*24L)+12L) ;


}

void shophealdesc35(UBYTE currline, unsigned char *descptr)
{
	unsigned char screenbuf4[12] ;

	memset(screenbuf4,0x5D,12L) ;
	//set_bkg_tiles2( 0, 13, 12, 1, (unsigned char*)screenbuf4);
	set_bkg_tiles2( 0, 16, 12, 1, (unsigned char*)screenbuf4);
	//set_bkg_tiles2( 0, 17, 12, 1, (unsigned char*)screenbuf4);

	set_bkg_tiles2(0,13,12,1,descptr+((UWORD)currline*36L)) ;
	set_bkg_tiles2(0,14,12,1,descptr+((UWORD)currline*36L)+12L) ;
	set_bkg_tiles2(0,15,12,1,descptr+((UWORD)currline*36L)+24L) ;


}

unsigned char guildlist35[] = {
	'K'+0x1D,'E'+0x1D,'Y'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,
	'T'+0x1D,'O'+0x1D,'R'+0x1D,'C'+0x1D,'H'+0x1D,'E'+0x1D,'S'+0x1D,
	'P'+0x1D,'O'+0x1D,'W'+0x1D,'D'+0x1D,'E'+0x1D,'R'+0x1D,'S'+0x1D,
	'G'+0x1D,'E'+0x1D,'M'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,
} ;

unsigned char guilddesclist35[] = {
	0x5D,0x5D,0x5D,0x5D, 'K'+0x1D,'E'+0x1D,'Y'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D,
	0x5D, '5'+0x48,'0'+0x48,'G'+0x1D,'P'+0x1D,0x5D,'E'+0x1D,'A'+0x1D,'C'+0x1D,'H'+0x1D,0x5D,0x5D,
	0x5D,0x5D, 'T'+0x1D,'O'+0x1D,'R'+0x1D,'C'+0x1D,'H'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,
	0x5D, '6'+0x48,0x5D,'G'+0x1D,'P'+0x1D,0x5D,'E'+0x1D,'A'+0x1D,'C'+0x1D,'H'+0x1D,0x5D,0x5D,
	0x5D,0x5D, 'P'+0x1D,'O'+0x1D,'W'+0x1D,'D'+0x1D,'E'+0x1D,'R'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,
	0x5D, 0x81,'0'+0x48,'G'+0x1D,'P'+0x1D,0x5D,'E'+0x1D,'A'+0x1D,'C'+0x1D,'H'+0x1D,0x5D,0x5D,
	0x5D,0x5D,0x5D,0x5D, 'G'+0x1D,'E'+0x1D,'M'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D,
	0x5D, '7'+0x48,'5'+0x48,'G'+0x1D,'P'+0x1D,0x5D,'E'+0x1D,'A'+0x1D,'C'+0x1D,'H'+0x1D,0x5D,0x5D,
} ;

unsigned char guildshop35_1[] = {
	'G'+0x1D,'U'+0x1D,'I'+0x1D,'L'+0x1D,'D'+0x1D,0x5D,'S'+0x1D,'H'+0x1D,'O'+0x1D,'P'+0x1D,0x5D,0x5D, 
} ;

unsigned char guildshop35_2[] = {
	'Y'+0x1D,'O'+0x1D,'U'+0x1D,'R'+0x1D,0x5D,'N'+0x1D,'E'+0x1D,'E'+0x1D,'D'+0x1D,'S'+0x1D,0x83,0x5D, 
} ;

unsigned char guildthank35_1[] = {
	'T'+0x1D,'H'+0x1D,'A'+0x1D,'N'+0x1D,'K'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x85,0x5D,0x5D, 
} ;
unsigned char guildthank35_2[] = {
	'C'+0x1D,'O'+0x1D,'M'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,'G'+0x1D,'A'+0x1D,'I'+0x1D,'N'+0x1D,0x82,0x5D, 
} ;

unsigned char guildnotenough35_1[]= {
	'I'+0x1D,0x86,'M'+0x1D,0x5D,'S'+0x1D,'O'+0x1D,'R'+0x1D,'R'+0x1D,'Y'+0x1D,0x85,0x5D,0x5D, 
} ;
unsigned char guildnotenough35_2[]= {
	'B'+0x1D,'U'+0x1D,'T'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,'H'+0x1D,'A'+0x1D,'V'+0x1D,'E'+0x1D, 
} ;
unsigned char guildnotenough35_3[]= {
	'N'+0x1D,'O'+0x1D,'T'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char guildnotenough35_4[]= {
	'F'+0x1D,'U'+0x1D,'N'+0x1D,'D'+0x1D,'S'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char guildmany35[] = {
	'H'+0x1D,'O'+0x1D,'W'+0x1D,0x5D,'M'+0x1D,'A'+0x1D,'N'+0x1D,'Y'+0x1D,0x83,0x5D,0x5D,0x5D, 
} ;

unsigned char healnotenough35_1[] = {
	'I'+0x1D,0x86,'M'+0x1D,0x5D,'S'+0x1D,'O'+0x1D,'R'+0x1D,'R'+0x1D,'Y'+0x1D,0x85,0x5D,0x5D, 
} ;
unsigned char healnotenough35_2[] = {
	'B'+0x1D,'U'+0x1D,'T'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char healnotenough35_3[] = {
	'H'+0x1D,'A'+0x1D,'S'+0x1D,'T'+0x1D,0x5D,'N'+0x1D,'O'+0x1D,'T'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char healnotenough35_4[] = {
	'G'+0x1D,'O'+0x1D,'L'+0x1D,'D'+0x1D,0x5D,'E'+0x1D,'N'+0x1D,'O'+0x1D,'U'+0x1D,'G'+0x1D,'H'+0x1D,0x84, 
} ;

unsigned char stable35_no1[] = {
	'A'+0x1D,'H'+0x1D,0x85,0x5D,'T'+0x1D,'O'+0x1D,'O'+0x1D,0x5D,'B'+0x1D,'A'+0x1D,'D'+0x1D,0x84, 
} ;
unsigned char stable35_no2[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,'S'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char stable35_no3[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,'B'+0x1D,'E'+0x1D,'S'+0x1D,'T'+0x1D,0x5D,'I'+0x1D,'N'+0x1D,0x5D, 
} ;
unsigned char stable35_no4[] = {
	'T'+0x1D,'O'+0x1D,'W'+0x1D,'N'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

UBYTE guildcosts35[] = {
	50,
	6,
	90,
	75
};

unsigned char teachclimbdat35[] = {
	'I'+0x1D,0x5D,'C'+0x1D,'A'+0x1D,'N'+0x1D,0x5D,'T'+0x1D,'E'+0x1D,'A'+0x1D,'C'+0x1D,'H'+0x1D,0x5D, 
	'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,'T'+0x1D,'O'+0x1D,0x5D,'C'+0x1D,'L'+0x1D,'I'+0x1D,'M'+0x1D,'B'+0x1D, 
	'F'+0x1D,'O'+0x1D,'R'+0x1D,0x5D,'5'+0x48,'0'+0x48,'0'+0x48,'0'+0x48,'G'+0x1D,'P'+0x1D,0x5D,0x5D, 
} ;

void doyesno35()
{

	yesnoglobal =   getmenuselection35(2,yesno35,NULL,NULL) ;

}
void dosellclimb35(UBYTE tnum, UBYTE pnum)
{


	UWORD price ;
	UBYTE nomore,p ;
	UBYTE yesno ;


	changemusic = extragame ? 17 : 7 ;
	nomore = 0 ;
	memset(screenbuf3,0x5D,12L) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(teachclimbdat35) ;
	writegamemessage(teachclimbdat35+12UL) ;
	writegamemessage(teachclimbdat35+24UL) ;
	writegamemessage(screenbuf3) ;

	price = 5000UL ;

	yesno = getmenuselection35(2,yesno35,NULL,NULL) ;
	memset(screenbuf3,0x5D,12L) ;
	if ( yesno==1 )
	{
		if ( players[pnum].gold < price )
		{
			writegamemessage(screenbuf3) ;
			writegamemessage(healnotenough35_1) ;
			writegamemessage(healnotenough35_2) ;
			writegamemessage(healnotenough35_3) ;
			writegamemessage(healnotenough35_4) ;
		}
		else
		{
			players[pnum].gold -= price ;
			party_specials |= 0x0002 ;
			specialsfx() ;
		} 
	}
	else
	{
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(stable35_no1) ;
	}


}

UWORD healcosts35[] = {
	100,
	200,
	500,
	900
};


unsigned char healer351[] = {
	'C'+0x1D,'L'+0x1D,'E'+0x1D,'R'+0x1D,'I'+0x1D,'C'+0x1D,'A'+0x1D,'L'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char healer352[] = {
	'H'+0x1D,'E'+0x1D,'A'+0x1D,'L'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char heallist35[] = {
	'C'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,
	'H'+0x1D,'E'+0x1D,'A'+0x1D,'L'+0x1D,0x5D,0x5D,0x5D,
	'R'+0x1D,'E'+0x1D,'S'+0x1D,'U'+0x1D,'R'+0x1D,'C'+0x1D,'T'+0x1D,
	'R'+0x1D,'E'+0x1D,'C'+0x1D,'A'+0x1D,'L'+0x1D,'L'+0x1D,0x5D,
} ;

unsigned char healdesclist35[] = {
	0x5D,0x5D,0x5D,'C'+0x1D,'U'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D,0x5D,0x5D,0x5D, 
	'C'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'P'+0x1D,'O'+0x1D,'I'+0x1D,'S'+0x1D,'O'+0x1D,'N'+0x1D,0x5D, 
	0x5D,0x5D,0x5D,'1'+0x48,'0'+0x48,'0'+0x48,0x5D,'G'+0x1D,'P'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,0x5D,'H'+0x1D,'E'+0x1D,'A'+0x1D,'L'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,'R'+0x1D,'E'+0x1D,'S'+0x1D,'T'+0x1D,'O'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'H'+0x1D,'P'+0x1D,0x5D, 
	0x5D,0x5D,0x5D,'2'+0x48,'0'+0x48,'0'+0x48,0x5D,'G'+0x1D,'P'+0x1D,0x5D,0x5D,0x5D, 
	'R'+0x1D,'E'+0x1D,'S'+0x1D,'U'+0x1D,'R'+0x1D,'R'+0x1D,'E'+0x1D,'C'+0x1D,'T'+0x1D,'I'+0x1D,'O'+0x1D,'N'+0x1D, 
	0x5D,'R'+0x1D,'A'+0x1D,'I'+0x1D,'S'+0x1D,'E'+0x1D,0x5D,'D'+0x1D,'E'+0x1D,'A'+0x1D,'D'+0x1D,0x5D, 
	0x5D,0x5D,0x5D,'5'+0x48,'0'+0x48,'0'+0x48,0x5D,'G'+0x1D,'P'+0x1D,0x5D,0x5D,0x5D, 
	0x5D,'R'+0x1D,'E'+0x1D,'C'+0x1D,'A'+0x1D,'L'+0x1D,'L'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D,0x5D,0x5D, 
	'R'+0x1D,'A'+0x1D,'I'+0x1D,'S'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,'S'+0x1D,'H'+0x1D,'E'+0x1D,'D'+0x1D,0x5D, 
	0x5D,0x5D,0x5D,0x81,'0'+0x48,'0'+0x48,0x5D,'G'+0x1D,'P'+0x1D,0x5D,0x5D,0x5D, 
} ;

unsigned char healbye35_1[] = {
	'F'+0x1D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
}; 
unsigned char healbye35_2[] = {
	'W'+0x1D,'E'+0x1D,'L'+0x1D,'L'+0x1D,0x5D,'M'+0x1D,'Y'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
}; 
unsigned char healbye35_3[] = {
	'C'+0x1D,'H'+0x1D,'I'+0x1D,'L'+0x1D,'D'+0x1D,'R'+0x1D,'E'+0x1D,'N'+0x1D,0x84,0x5D,0x5D,0x5D, 
}; 


unsigned char notinjured35[] = {
	'N'+0x1D,'O'+0x1D,'T'+0x1D,0x5D,'I'+0x1D,'N'+0x1D,'J'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,'D'+0x1D,0x82, 
} ;

unsigned char notpoisoned35[] = {
	'N'+0x1D,'O'+0x1D,'T'+0x1D,0x5D,'P'+0x1D,'O'+0x1D,'I'+0x1D,'S'+0x1D,'O'+0x1D,'N'+0x1D,'E'+0x1D,'D'+0x1D, 
} ;
unsigned char notdead35[] = {
	'N'+0x1D,'O'+0x1D,'T'+0x1D,0x5D,'D'+0x1D,'E'+0x1D,'A'+0x1D,'D'+0x1D,0x82,0x5D,0x5D,0x5D, 
} ;
unsigned char notashes35[] = {
	'N'+0x1D,'O'+0x1D,'T'+0x1D,0x5D,'A'+0x1D,'S'+0x1D,'H'+0x1D,'E'+0x1D,'S'+0x1D,0x82,0x5D,0x5D, 
} ;

unsigned char donedat35[] = {
	'D'+0x1D,'O'+0x1D,'N'+0x1D,'E'+0x1D,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d,0x5d
};

void healsfx35() 
{
	UBYTE s,t ;

	disable_interrupts2() ;

	VBK_REG = 1 ;
	for ( s = 0 ; s!=11 ; s++ )
	{
		get_bkg_tiles2(1,s+1,11,1,screenbuf3) ;
		for ( t = 0 ; t!=11 ; t++ )
			screenbuf3[t] += 4 ;
		set_bkg_tiles2(1,s+1,11,1,screenbuf3) ;
	}
	VBK_REG = 0 ;
	enable_interrupts2() ;
	magicsfx2(0,12,0) ;
	disable_interrupts2() ;

	VBK_REG = 1 ;
	for ( s = 0 ; s!=11 ; s++ )
	{
		get_bkg_tiles2(1,s+1,11,1,screenbuf3) ;
		for ( t = 0 ; t!=11 ; t++ )
			screenbuf3[t] -= 4 ;
		set_bkg_tiles2(1,s+1,11,1,screenbuf3) ;
	}
	VBK_REG = 0 ;
	enable_interrupts2() ;

}

void dohealer35(UBYTE tnum, UBYTE pnum)
{

	UBYTE price ;
	UBYTE nomore,p ;
	UBYTE whichitem ;
	UBYTE *numptr ;
	UBYTE healpnum ;

	changemusic = extragame ? 17 : 7 ;

	nomore = 0 ;
	memset(screenbuf3,0x5D,12L) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(healer351) ;
	writegamemessage(healer352) ;
	writegamemessage(screenbuf3) ;
	waitpadup() ;
	waitpad(0xFF) ;
	while ( !nomore )
	{

		memset(screenbuf3,0x5D,12L) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(guildshop35_2) ;
		whichitem = getmenuselection35(4,heallist35,shophealdesc35,healdesclist35) ;
		if ( whichitem==99 )
		{
			memset(screenbuf3,0x5D,12L) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(healbye35_1) ;
			writegamemessage(healbye35_2) ;
			writegamemessage(healbye35_3) ;
			return ;

		}


		healpnum = choosechar35() ;
		if ( healpnum==99 )
			continue ;

		if ( players[pnum].gold < healcosts35[whichitem] )
		{
			memset(screenbuf3,0x5D,12L) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(healnotenough35_1) ;
			writegamemessage(healnotenough35_2) ;
			writegamemessage(healnotenough35_3) ;
			writegamemessage(healnotenough35_4) ;


		}
		else
		{
			memset(screenbuf3,0x5D,12L) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			if ( whichitem==0 )
			{
				if ( players[healpnum].status==1 )
				{
					players[pnum].gold -= healcosts35[whichitem] ;
					players[healpnum].status = 0 ;
					healsfx35() ;
					writegamemessage(donedat35) ;

				}
				else
				{
					writegamemessage(notpoisoned35); 

				}


			}
			else
				if ( whichitem==1 )
			{
				if ( (players[healpnum].status<2)&&(players[healpnum].currHP < players[healpnum].maxHP) )
				{
					players[pnum].gold -= healcosts35[whichitem] ;
					players[healpnum].currHP = players[healpnum].maxHP ;
					healsfx35() ;
					writegamemessage(donedat35) ;

				}
				else
				{
					writegamemessage(notinjured35); 

				}

			}
			else
				if ( whichitem==2 )
			{
				if ( players[healpnum].status==2 )
				{
					players[pnum].gold -= healcosts35[whichitem] ;
					players[healpnum].status = 0 ;
					players[healpnum].currHP = 1L ;
					healsfx35() ;
					writegamemessage(donedat35) ;

				}
				else
				{
					writegamemessage(notdead35); 

				}

			}
			else
			{
				if ( players[healpnum].status==3 )
				{
					players[pnum].gold -= healcosts35[whichitem] ;
					players[healpnum].status = 0 ;
					players[healpnum].currHP = 1L ;
					healsfx35() ;
					writegamemessage(donedat35) ;

				}
				else
				{
					writegamemessage(notashes35); 

				}

			}

		}
		for ( p=0; p<4 ; p++ )
			charscreen35(&(players[p]),p) ;
		waitpadup() ;
		waitpad(0xFF) ;

	}




}

unsigned char stable35_1[] = {
	'E'+0x1D,'Q'+0x1D,'U'+0x1D,'I'+0x1D,'N'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char stable35_2[] = {
	'E'+0x1D,'M'+0x1D,'P'+0x1D,'O'+0x1D,'R'+0x1D,'I'+0x1D,'U'+0x1D,'M'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char stable35_3[] = {
	'0'+0x48,0x5D,'H'+0x1D,'O'+0x1D,'R'+0x1D,'S'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char stable35_4[] = {
	'C'+0x1D,'O'+0x1D,'S'+0x1D,'T'+0x1D,0x5D,'0'+0x48,'0'+0x48,'0'+0x48,'G'+0x1D,'P'+0x1D,0x5D,0x5D, 
} ;
unsigned char stable35_5[] = {
	'W'+0x1D,'I'+0x1D,'L'+0x1D,'L'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char stable35_6[] = {
	'B'+0x1D,'U'+0x1D,'Y'+0x1D,0x83,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;


unsigned char stable35_yes1[] = {
	'M'+0x1D,'A'+0x1D,'Y'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char stable35_yes2[] = {
	'R'+0x1D,'I'+0x1D,'D'+0x1D,'E'+0x1D,0x5D,'F'+0x1D,'A'+0x1D,'S'+0x1D,'T'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char stable35_yes3[] = {
	'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,'T'+0x1D,'R'+0x1D,'U'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char stable35_yes4[] = {
	'F'+0x1D,'R'+0x1D,'I'+0x1D,'E'+0x1D,'N'+0x1D,'D'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

void dostable35(UBYTE tnum, UBYTE pnum)
{

	UWORD price ;
	UBYTE nomore,p ;
	UBYTE yesno ;


	changemusic = extragame ? 17 : 7 ;
	nomore = 0 ;
	memset(screenbuf3,0x5D,12L) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(stable35_1) ;
	writegamemessage(stable35_2) ;
	writegamemessage(screenbuf3) ;
	waitpadup() ;
	waitpad(0xFF) ;

	memset(screenbuf3,0x5D,12L) ;
	writegamemessage(screenbuf3) ;
	memcpy(screenbuf3,stable35_3,12L); 
	for ( p=0 ; p<4 ; p++ )
		if ( players[p].inparty )
			(screenbuf3[0])++ ;
	writegamemessage(screenbuf3) ;
	memcpy(screenbuf3,stable35_4,12L); 
	price = 0L ;
	for ( p=0 ; p<4 ; p++ )
		if ( players[p].inparty )
		{
			screenbuf3[5] += 2 ;
			price += 200L ;
		}
	writegamemessage(screenbuf3) ;
	writegamemessage(stable35_5) ;
	writegamemessage(stable35_6) ;

	yesno = getmenuselection35(2,yesno35,NULL,NULL) ;
	memset(screenbuf3,0x5D,12L) ;
	writegamemessage(screenbuf3) ;
	if ( yesno==1 )
	{
		if ( players[pnum].gold < price )
		{
			writegamemessage(healnotenough35_1) ;
			writegamemessage(healnotenough35_2) ;
			writegamemessage(healnotenough35_3) ;
			writegamemessage(healnotenough35_4) ;


		}
		else
		{
			writegamemessage(stable35_yes1) ;
			writegamemessage(stable35_yes2) ;
			writegamemessage(stable35_yes3) ;
			writegamemessage(stable35_yes4) ;
			players[pnum].gold -= price ;
			playerscreentile = 0x0D ;
			transport = 2 ;
		} 


	}
	else
	{
		writegamemessage(stable35_no1) ;
		writegamemessage(stable35_no2) ;
		writegamemessage(stable35_no3) ;
		writegamemessage(stable35_no4) ;


	}




}


unsigned char oracle35_1[] = {
	'R'+0x1D,'A'+0x1D,'D'+0x1D,'R'+0x1D,'I'+0x1D,'O'+0x1D,'N'+0x1D,0x8A,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_2[] = {
	'P'+0x1D,'R'+0x1D,'O'+0x1D,'P'+0x1D,'H'+0x1D,'E'+0x1D,'T'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D,0x5D, 
} ;
unsigned char oracle35_3[] = {
	'L'+0x1D,'I'+0x1D,'F'+0x1D,'E'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_4[] = {
	'H'+0x1D,'O'+0x1D,'W'+0x1D,0x5D,'M'+0x1D,'A'+0x1D,'N'+0x1D,'Y'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_5[] = {
	'1'+0x48,'0'+0x48,'0'+0x48,'G'+0x1D,'P'+0x1D,0x5D,'I'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_6[] = {
	'Y'+0x1D,'O'+0x1D,'U'+0x1D,'R'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_7[] = {
	'O'+0x1D,'F'+0x1D,'F'+0x1D,'E'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D,0x83,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_pre1[] = {
	'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,'S'+0x1D,'O'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,0x5D, 
} ;
unsigned char oracle35_pre2[] = {
	'S'+0x1D,'A'+0x1D,'G'+0x1D,'E'+0x1D,0x5D,'S'+0x1D,'A'+0x1D,'I'+0x1D,'D'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_pre3[] = {
	'U'+0x1D,'N'+0x1D,'T'+0x1D,'O'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_A11[] = {
	'I'+0x1D,'F'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,'C'+0x1D,'A'+0x1D,'N'+0x1D,0x5D, 
} ;
unsigned char oracle35_A12[] = {
	'S'+0x1D,'O'+0x1D,'L'+0x1D,'V'+0x1D,'E'+0x1D,0x5D,'M'+0x1D,'Y'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A13[] = {
	'R'+0x1D,'H'+0x1D,'Y'+0x1D,'M'+0x1D,'E'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x86,'L'+0x1D,'L'+0x1D, 
} ;
unsigned char oracle35_A14[] = {
	'L'+0x1D,'E'+0x1D,'A'+0x1D,'R'+0x1D,'N'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A15[] = {
	'M'+0x1D,'A'+0x1D,'R'+0x1D,'K'+0x1D,'S'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A16[] = {
	'P'+0x1D,'L'+0x1D,'A'+0x1D,'Y'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A17[] = {
	'C'+0x1D,'A'+0x1D,'R'+0x1D,'D'+0x1D,'S'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A18[] = {
	'H'+0x1D,'I'+0x1D,'D'+0x1D,'D'+0x1D,'E'+0x1D,'N'+0x1D,0x5D,'H'+0x1D,'O'+0x1D,'L'+0x1D,'Y'+0x1D,0x5D, 
} ;
unsigned char oracle35_A19[] = {
	'S'+0x1D,'H'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_A21[] = {
	'O'+0x1D,'F'+0x1D,0x5D,'M'+0x1D,'A'+0x1D,'R'+0x1D,'K'+0x1D,'S'+0x1D,0x5D,'I'+0x1D,0x5D,0x5D, 
} ;
unsigned char oracle35_A22[] = {
	'S'+0x1D,'A'+0x1D,'Y'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A23[] = {
	'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'B'+0x1D,'U'+0x1D,'T'+0x1D,0x5D,'4'+0x48,0x5D,'O'+0x1D,'F'+0x1D, 
} ;
unsigned char oracle35_A24[] = {
	'F'+0x1D,'I'+0x1D,'R'+0x1D,'E'+0x1D,0x85,0x5D,'F'+0x1D,'O'+0x1D,'R'+0x1D,'C'+0x1D,'E'+0x1D,0x85, 
} ;
unsigned char oracle35_A25[] = {
	'S'+0x1D,'N'+0x1D,'A'+0x1D,'K'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A26[] = {
	'K'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_A31[] = {
	'L'+0x1D,'E'+0x1D,'A'+0x1D,'R'+0x1D,'N'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,'I'+0x1D,'R'+0x1D,0x5D, 
} ;
unsigned char oracle35_A32[] = {
	'U'+0x1D,'S'+0x1D,'E'+0x1D,0x5D,'I'+0x1D,'N'+0x1D,0x5D,'D'+0x1D,'E'+0x1D,'V'+0x1D,'I'+0x1D,'L'+0x1D, 
} ;
unsigned char oracle35_A33[] = {
	'G'+0x1D,'U'+0x1D,'A'+0x1D,'R'+0x1D,'D'+0x1D,0x85,0x5D,'O'+0x1D,'R'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A34[] = {
	'D'+0x1D,'E'+0x1D,'A'+0x1D,'T'+0x1D,'H'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x86,'L'+0x1D,'L'+0x1D, 
} ;
unsigned char oracle35_A35[] = {
	'S'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,'L'+0x1D,'Y'+0x1D,0x5D,'B'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D, 
} ;

unsigned char oracle35_A41[] = {
	'S'+0x1D,'H'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A42[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A43[] = {
	'A'+0x1D,'G'+0x1D,'A'+0x1D,'I'+0x1D,'N'+0x1D,0x5D,'B'+0x1D,'U'+0x1D,'T'+0x1D,0x5D,'4'+0x48,0x5D, 
} ;
unsigned char oracle35_A44[] = {
	'T'+0x1D,'O'+0x1D,0x5D,'W'+0x1D,'H'+0x1D,'I'+0x1D,'C'+0x1D,'H'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D, 
} ;
unsigned char oracle35_A45[] = {
	'G'+0x1D,'O'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,'P'+0x1D,'R'+0x1D,'A'+0x1D,'Y'+0x1D,0x5D, 
} ;

unsigned char oracle35_A51[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,'I'+0x1D,'R'+0x1D,0x5D,'U'+0x1D,'S'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,0x5D, 
} ;
unsigned char oracle35_A52[] = {
	'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A53[] = {
	'I'+0x1D,'N'+0x1D,'U'+0x1D,'M'+0x1D,'E'+0x1D,'R'+0x1D,'A'+0x1D,'B'+0x1D,'L'+0x1D,'E'+0x1D,0x5D,0x5D, 
} ;
unsigned char oracle35_A54[] = {
	'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,'C'+0x1D,'L'+0x1D,'U'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A55[] = {
	'T'+0x1D,'H'+0x1D,'R'+0x1D,'O'+0x1D,'U'+0x1D,'G'+0x1D,'H'+0x1D,'O'+0x1D,'U'+0x1D,'T'+0x1D,0x5D,'I'+0x1D, 
} ;
unsigned char oracle35_A56[] = {
	'S'+0x1D,'A'+0x1D,'Y'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_A61[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,'C'+0x1D,'A'+0x1D,'R'+0x1D,'D'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A62[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,'I'+0x1D,'R'+0x1D,0x5D,'S'+0x1D,'U'+0x1D,'I'+0x1D,'T'+0x1D,'S'+0x1D,0x5D, 
} ;
unsigned char oracle35_A63[] = {
	'D'+0x1D,'O'+0x1D,0x5D,'N'+0x1D,'U'+0x1D,'M'+0x1D,'B'+0x1D,'E'+0x1D,'R'+0x1D,0x5D,'4'+0x48,0x85, 
} ;
unsigned char oracle35_A64[] = {
	'C'+0x1D,'A'+0x1D,'L'+0x1D,'L'+0x1D,'E'+0x1D,'D'+0x1D,0x5D,'S'+0x1D,'O'+0x1D,'L'+0x1D,0x85,0x5D, 
} ;
unsigned char oracle35_A65[] = {
	'M'+0x1D,'O'+0x1D,'O'+0x1D,'N'+0x1D,0x85,0x5D,'D'+0x1D,'E'+0x1D,'A'+0x1D,'T'+0x1D,'H'+0x1D,0x5D, 
} ;
unsigned char oracle35_A66[] = {
	'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,'L'+0x1D,'O'+0x1D,'V'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_A71[] = {
	'U'+0x1D,'N'+0x1D,'T'+0x1D,'O'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A72[] = {
	'M'+0x1D,'O'+0x1D,'N'+0x1D,'T'+0x1D,'O'+0x1D,'R'+0x1D,'S'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'O'+0x1D,'U'+0x1D, 
} ;
unsigned char oracle35_A73[] = {
	'M'+0x1D,'U'+0x1D,'S'+0x1D,'T'+0x1D,0x5D,'G'+0x1D,'O'+0x1D,0x5D,'F'+0x1D,'O'+0x1D,'R'+0x1D,0x5D, 
} ;
unsigned char oracle35_A74[] = {
	'G'+0x1D,'U'+0x1D,'I'+0x1D,'D'+0x1D,'A'+0x1D,'N'+0x1D,'C'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A75[] = {
	'F'+0x1D,'R'+0x1D,'O'+0x1D,'M'+0x1D,0x5D,'A'+0x1D,'B'+0x1D,'O'+0x1D,'V'+0x1D,'E'+0x1D,0x5D,0x5D, 
} ;

unsigned char oracle35_A81[] = {
	'T'+0x1D,'O'+0x1D,0x5D,'A'+0x1D,'I'+0x1D,'D'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,'E'+0x1D,0x5D, 
} ;
unsigned char oracle35_A82[] = {
	'I'+0x1D,'N'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'Y'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A83[] = {
	'C'+0x1D,'R'+0x1D,'Y'+0x1D,'P'+0x1D,'T'+0x1D,'I'+0x1D,'C'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A84[] = {
	'S'+0x1D,'E'+0x1D,'A'+0x1D,'R'+0x1D,'C'+0x1D,'H'+0x1D,0x85,0x5D,'T'+0x1D,'O'+0x1D,0x5D,0x5D, 
} ;
unsigned char oracle35_A85[] = {
	'D'+0x1D,'U'+0x1D,'N'+0x1D,'G'+0x1D,'E'+0x1D,'O'+0x1D,'N'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A86[] = {
	'T'+0x1D,'H'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,'M'+0x1D,'U'+0x1D,'S'+0x1D,'T'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_A87[] = {
	'F'+0x1D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_A91[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'S'+0x1D,'E'+0x1D,'E'+0x1D,'K'+0x1D,0x5D,0x5D, 
} ;
unsigned char oracle35_A92[] = {
	'O'+0x1D,'U'+0x1D,'T'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,'L'+0x1D,'O'+0x1D,'R'+0x1D,'D'+0x1D, 
} ;
unsigned char oracle35_A93[] = {
	'O'+0x1D,'F'+0x1D,0x5D,'T'+0x1D,'I'+0x1D,'M'+0x1D,'E'+0x1D,0x5D,'T'+0x1D,'O'+0x1D,0x5D,0x5D, 
} ;
unsigned char oracle35_A94[] = {
	'H'+0x1D,'E'+0x1D,'L'+0x1D,'P'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,'I'+0x1D,'F'+0x1D,0x5D, 
} ;
unsigned char oracle35_A95[] = {
	'H'+0x1D,'E'+0x1D,0x5D,'C'+0x1D,'A'+0x1D,'R'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_more1[] = {
	'M'+0x1D,'O'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_more2[] = {
	'O'+0x1D,'F'+0x1D,'F'+0x1D,'E'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D,0x83,0x5D,0x5D,0x5D, 
} ;

unsigned char oracle35_leave1[] = {
	'F'+0x1D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_leave2[] = {
	'W'+0x1D,'E'+0x1D,'L'+0x1D,'L'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,0x5D,0x5D,0x5D, 
} ;
unsigned char oracle35_leave3[] = {
	'G'+0x1D,'O'+0x1D,'O'+0x1D,'D'+0x1D,0x5D,'L'+0x1D,'U'+0x1D,'C'+0x1D,'K'+0x1D,0x82,0x5D,0x5D, 
} ;

unsigned char teachbowdat35[] = {
	'I'+0x1D,0x5D,'C'+0x1D,'A'+0x1D,'N'+0x1D,0x5D,'T'+0x1D,'E'+0x1D,'A'+0x1D,'C'+0x1D,'H'+0x1D,0x5D, 
	'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,'G'+0x1D,'R'+0x1D,'A'+0x1D,'C'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
	'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,'C'+0x1D,'O'+0x1D,'U'+0x1D,'R'+0x1D,'T'+0x1D,'E'+0x1D,'S'+0x1D,'Y'+0x1D, 
	'F'+0x1D,'O'+0x1D,'R'+0x1D,0x5D,'5'+0x48,'0'+0x48,'0'+0x48,'0'+0x48,'G'+0x1D,'P'+0x1D,0x5D,0x5D, 
} ;

void dosellbow35(UBYTE tnum, UBYTE pnum)
{



	UWORD price ;
	UBYTE nomore,p ;
	UBYTE yesno ;


	changemusic = extragame ? 17 : 7 ;
	nomore = 0 ;
	memset(screenbuf3,0x5D,12L) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(teachbowdat35) ;
	writegamemessage(teachbowdat35+12UL) ;
	writegamemessage(teachbowdat35+24UL) ;
	writegamemessage(teachbowdat35+36UL) ;

	price = 5000UL ;

	yesno = getmenuselection35(2,yesno35,NULL,NULL) ;
	memset(screenbuf3,0x5D,12L) ;
	if ( yesno==1 )
	{
		if ( players[pnum].gold < price )
		{
			writegamemessage(screenbuf3) ;
			writegamemessage(healnotenough35_1) ;
			writegamemessage(healnotenough35_2) ;
			writegamemessage(healnotenough35_3) ;
			writegamemessage(healnotenough35_4) ;
		}
		else
		{
			players[pnum].gold -= price ;
			party_specials |= 0x0080 ;
			specialsfx() ;
		} 
	}
	else
	{
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(stable35_no1) ;
	}




}


unsigned char british35_1[] = {
	'H'+0x1D,'E'+0x1D,0x5D,'S'+0x1D,'E'+0x1D,'E'+0x1D,'M'+0x1D,'S'+0x1D,0x5D,'T'+0x1D,'O'+0x1D,0x5D, 
};
unsigned char british35_2[] = {
	'I'+0x1D,'G'+0x1D,'N'+0x1D,'O'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,0x5D, 
};

unsigned char british35_done[] = {
	'N'+0x1D,'O'+0x1D,0x5D,'M'+0x1D,'O'+0x1D,'R'+0x1D,'E'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D, 
};


unsigned char british35_mark1[] = {
	'S'+0x1D,'E'+0x1D,'E'+0x1D,'K'+0x1D,0x5D,'Y'+0x1D,'E'+0x1D,0x85,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char british35_mark2[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,'M'+0x1D,'A'+0x1D,'R'+0x1D,'K'+0x1D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char british35_mark3[] = {
	'O'+0x1D,'F'+0x1D,0x5D,'K'+0x1D,'I'+0x1D,'N'+0x1D,'G'+0x1D,'S'+0x1D,0x82,0x5D,0x5D,0x5D, 
};

unsigned char british35_up1[] = {
	'T'+0x1D,'H'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,'A'+0x1D,'R'+0x1D,'T'+0x1D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char british35_up2[] = {
	'G'+0x1D,'R'+0x1D,'E'+0x1D,'A'+0x1D,'T'+0x1D,'E'+0x1D,'R'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D, 
};

unsigned char british35_notyet1[] = {
	'E'+0x1D,'X'+0x1D,'P'+0x1D,'E'+0x1D,'R'+0x1D,'I'+0x1D,'E'+0x1D,'N'+0x1D,'C'+0x1D,'E'+0x1D,0x5D,0x5D, 
};
unsigned char british35_notyet2[] = {
	'M'+0x1D,'O'+0x1D,'R'+0x1D,'E'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};

void magiceffect35(UBYTE spellnum)
{
	UBYTE p ;

	VBK_REG=1 ;
	get_bkg_tiles2(1,1,11,11,(unsigned char*)0xBF80) ;

	for ( p=0 ; p < 121 ; p++ )
		if ( *((unsigned char*)0xBF80+(UWORD)p) < 4 )
			*((unsigned char*)0xBF80+(UWORD)p) += 4 ;

	set_bkg_tiles2(1,1,11,11,(unsigned char*)0xBF80) ;
	magicsfx2(0,10+(spellnum*2),0) ;

	for ( p=0 ; p < 121 ; p++ )
		if ( *((unsigned char*)0xBF80+(UWORD)p) > 3 )
			*((unsigned char*)0xBF80+(UWORD)p) -= 4 ;

	set_bkg_tiles2(1,1,11,11,(unsigned char*)0xBF80) ;
	VBK_REG=0 ;

}

void dobritish35(UBYTE tnum, UBYTE pnum)
{
	UBYTE reallevel ;

//	changemusic = extragame ? 13 : 2 ;

	memset(screenbuf3,0x5D,12L) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(british35_1) ;
	writegamemessage(british35_2) ;

}

unsigned char pub35_leavegood1[] = {
	'I'+0x1D,'T'+0x1D,0x86,'S'+0x1D,0x5D,'B'+0x1D,'E'+0x1D,'E'+0x1D,'N'+0x1D,0x5D,'A'+0x1D,0x5d
};

unsigned char pub35_leavegood2[] = {
	'P'+0x1D,'L'+0x1D,'E'+0x1D,'A'+0x1D,'S'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,0x82,0x5d,0x5d,0x5d
};

unsigned char pub35_leavebad1[] = {
	'L'+0x1D,'E'+0x1D,'A'+0x1D,'V'+0x1D,'E'+0x1D,0x5D,'M'+0x1D,'Y'+0x1D,0x5d,0x5d,0x5d,0x5d
} ;

unsigned char pub35_leavebad2[] = {
	'S'+0x1D,'H'+0x1D,'O'+0x1D,'P'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5d,0x5d,0x5d,0x5d
};

unsigned char pub35_leavebad3[] = {
	'S'+0x1D,'C'+0x1D,'U'+0x1D,'M'+0x1D,0x82,0x82,0x82,0x5d,0x5d,0x5d,0x5d,0x5d
};

unsigned char pub35_another[] = {
	'A'+0x1D,'N'+0x1D,'O'+0x1D,'T'+0x1D,'H'+0x1D,'E'+0x1D,'R'+0x1D,0x83,0x5d,0x5d,0x5d,0x5d
};


unsigned char pub35_dat1[] = {
	'W'+0x1D,'E'+0x1D,'L'+0x1D,'C'+0x1D,'O'+0x1D,'M'+0x1D,'E'+0x1D,0x5D,'T'+0x1D,'O'+0x1D,0x5d,0x5d
} ;

unsigned char pub35_dat2[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,'P'+0x1D,'U'+0x1D,'B'+0x1D,0x82,0x5d,0x5d,0x5d,0x5d
};

unsigned char pub35_dat3[] = {
	'H'+0x1D,'E'+0x1D,'R'+0x1D,'E'+0x1D,0x85,0x5D,'F'+0x1D,'R'+0x1D,'I'+0x1D,'E'+0x1D,'N'+0x1D,'D'+0x1D
} ;

unsigned char pub35_dat4[] = {
	'H'+0x1D,'A'+0x1D,'V'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,0x5D,'D'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'K'+0x1D
}; 

unsigned char pub35_dat5[] = {
	'I'+0x1D,'T'+0x1D,0x5D,'C'+0x1D,'O'+0x1D,'S'+0x1D,'T'+0x1D,'S'+0x1D,0x5D,0x7F,'G'+0x1D,'P'+0x1D
};

unsigned char pub35_dat6[] = {
	'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,'P'+0x1D,'A'+0x1D,'Y'+0x1D,0x8A,0x5d,0x5d,0x5d,0x5d
} ;

unsigned char pub35_msg11[] = {
	'T'+0x1D,'H'+0x1D,'A'+0x1D,'N'+0x1D,'K'+0x1D,0x5D,'Y'+0x1D,'O'+0x1D,'U'+0x1D,0x5D,0x5D,0x5D, 
} ;
unsigned char pub35_msg12[] = {
	'K'+0x1D,'I'+0x1D,'N'+0x1D,'D'+0x1D,'L'+0x1D,'Y'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D, 
};

unsigned char pub35_msg21[] = {
	'A'+0x1D,'M'+0x1D,'B'+0x1D,'R'+0x1D,'O'+0x1D,'S'+0x1D,'I'+0x1D,'A'+0x1D,0x85,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg22[] = {
	'E'+0x1D,'V'+0x1D,'E'+0x1D,'R'+0x1D,0x5D,'H'+0x1D,'E'+0x1D,'A'+0x1D,'R'+0x1D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg23[] = {
	'O'+0x1D,'F'+0x1D,0x5D,'I'+0x1D,'T'+0x1D,0x83,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};

unsigned char pub35_msg31[] = {
	'D'+0x1D,'A'+0x1D,'W'+0x1D,'N'+0x1D,0x85,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg32[] = {
	'C'+0x1D,'I'+0x1D,'T'+0x1D,'Y'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg33[] = {
	'M'+0x1D,'Y'+0x1D,'T'+0x1D,'H'+0x1D,'S'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg34[] = {
	'M'+0x1D,'A'+0x1D,'G'+0x1D,'I'+0x1D,'C'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};

unsigned char pub35_msg41[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg42[] = {
	'C'+0x1D,'O'+0x1D,'N'+0x1D,'J'+0x1D,'U'+0x1D,'N'+0x1D,'C'+0x1D,'T'+0x1D,'I'+0x1D,'O'+0x1D,'N'+0x1D,0x5D, 
};
unsigned char pub35_msg43[] = {
	'O'+0x1D,'F'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg44[] = {
	'M'+0x1D,'O'+0x1D,'O'+0x1D,'N'+0x1D,'S'+0x1D,0x5D,'F'+0x1D,'I'+0x1D,'N'+0x1D,'D'+0x1D,'S'+0x1D,0x5D, 
};
unsigned char pub35_msg45[] = {
	'L'+0x1D,'I'+0x1D,'N'+0x1D,'K'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};

unsigned char pub35_msg51[] = {
	'N'+0x1D,'A'+0x1D,'S'+0x1D,'T'+0x1D,'Y'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg52[] = {
	'C'+0x1D,'R'+0x1D,'E'+0x1D,'A'+0x1D,'T'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,'S'+0x1D,0x85,0x5D,0x5D, 
};
unsigned char pub35_msg53[] = {
	'N'+0x1D,'A'+0x1D,'S'+0x1D,'T'+0x1D,'Y'+0x1D,0x5D,'D'+0x1D,'A'+0x1D,'R'+0x1D,'K'+0x1D,0x85,0x5D, 
};
unsigned char pub35_msg54[] = {
	'S'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg55[] = {
	'R'+0x1D,'E'+0x1D,'A'+0x1D,'D'+0x1D,'Y'+0x1D,0x5D,'B'+0x1D,'E'+0x1D,'F'+0x1D,'O'+0x1D,'R'+0x1D,'E'+0x1D, 
};
unsigned char pub35_msg56[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,'E'+0x1D,0x5D,'E'+0x1D,'M'+0x1D,'B'+0x1D,'A'+0x1D,'R'+0x1D,'K'+0x1D,0x82, 
};

unsigned char pub35_msg61[] = {
	'N'+0x1D,'O'+0x1D,'N'+0x1D,'E'+0x1D,0x5D,'R'+0x1D,'E'+0x1D,'T'+0x1D,'U'+0x1D,'R'+0x1D,'N'+0x1D,0x5D, 
};
unsigned char pub35_msg62[] = {
	'O'+0x1D,'R'+0x1D,0x5D,'S'+0x1D,'O'+0x1D,0x5D,'I'+0x1D,0x86,'M'+0x1D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg63[] = {
	'T'+0x1D,'O'+0x1D,'L'+0x1D,'D'+0x1D,0x5D,'F'+0x1D,'R'+0x1D,'O'+0x1D,'M'+0x1D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg64[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,'P'+0x1D,'O'+0x1D,'O'+0x1D,'L'+0x1D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg65[] = {
	'D'+0x1D,'A'+0x1D,'R'+0x1D,'K'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg66[] = {
	'C'+0x1D,'O'+0x1D,'L'+0x1D,'D'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};

unsigned char pub35_msg71[] = {
	'S'+0x1D,'H'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D,0x5D, 
};
unsigned char pub35_msg72[] = {
	'K'+0x1D,'N'+0x1D,'O'+0x1D,'W'+0x1D,'L'+0x1D,'E'+0x1D,'D'+0x1D,'G'+0x1D,'E'+0x1D,0x85,0x5D,0x5D, 
};
unsigned char pub35_msg73[] = {
	'S'+0x1D,'H'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'E'+0x1D,'S'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D,0x5D, 
};
unsigned char pub35_msg74[] = {
	'S'+0x1D,'T'+0x1D,'R'+0x1D,'E'+0x1D,'N'+0x1D,'G'+0x1D,'T'+0x1D,'H'+0x1D,0x85,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg75[] = {
	'A'+0x1D,'L'+0x1D,'L'+0x1D,0x5D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'L'+0x1D,'O'+0x1D,'S'+0x1D,'T'+0x1D, 
};
unsigned char pub35_msg76[] = {
	'I'+0x1D,'N'+0x1D,'T'+0x1D,'O'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg77[] = {
	'B'+0x1D,'R'+0x1D,'I'+0x1D,'N'+0x1D,'K'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};

unsigned char pub35_msg81[] = {
	'F'+0x1D,'O'+0x1D,'U'+0x1D,'N'+0x1D,'T'+0x1D,'A'+0x1D,'I'+0x1D,'N'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg82[] = {
	'F'+0x1D,'A'+0x1D,'I'+0x1D,'R'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg83[] = {
	'F'+0x1D,'O'+0x1D,'U'+0x1D,'N'+0x1D,'T'+0x1D,'A'+0x1D,'I'+0x1D,'N'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg84[] = {
	'F'+0x1D,'O'+0x1D,'U'+0x1D,'L'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg85[] = {
	'A'+0x1D,'L'+0x1D,'L'+0x1D,0x5D,'A'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg86[] = {
	'F'+0x1D,'O'+0x1D,'U'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,'I'+0x1D,'N'+0x1D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg87[] = {
	'D'+0x1D,'U'+0x1D,'N'+0x1D,'G'+0x1D,'E'+0x1D,'O'+0x1D,'N'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg88[] = {
	'B'+0x1D,'O'+0x1D,'W'+0x1D,'E'+0x1D,'L'+0x1D,0x82,0x5D,0x5D,0x5D,0x5D,0x5D,0x5D, 
};

unsigned char pub35_msg91[] = {
	'E'+0x1D,'X'+0x1D,'O'+0x1D,'D'+0x1D,'U'+0x1D,'S'+0x1D,0x8A,0x5D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg92[] = {
	'U'+0x1D,'L'+0x1D,'T'+0x1D,'I'+0x1D,'M'+0x1D,'A'+0x1D,0x5D,'I'+0x1D,'I'+0x1D,'I'+0x1D,0x5D,0x5D, 
};
unsigned char pub35_msg93[] = {
	'W'+0x1D,'H'+0x1D,'I'+0x1D,'C'+0x1D,'H'+0x1D,0x5D,'I'+0x1D,'S'+0x1D,0x5D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg94[] = {
	'N'+0x1D,'E'+0x1D,'X'+0x1D,'T'+0x1D,0x83,0x5D,'N'+0x1D,'O'+0x1D,'W'+0x1D,0x5D,0x5D,0x5D, 
};
unsigned char pub35_msg95[] = {
	'C'+0x1D,'O'+0x1D,'U'+0x1D,'L'+0x1D,'D'+0x1D,0x5D,'B'+0x1D,'E'+0x1D,0x82,0x5D,0x5D,0x5D, 
};

unsigned char pub35_msg101[] = {
	'S'+0x1D,'E'+0x1D,'E'+0x1D,'K'+0x1D,0x5D,'Y'+0x1D,'E'+0x1D,0x5D,'O'+0x1D,'U'+0x1D,'T'+0x1D,0x5D, 
};
unsigned char pub35_msg102[] = {
	'T'+0x1D,'H'+0x1D,'E'+0x1D,0x5D,'L'+0x1D,'O'+0x1D,'R'+0x1D,'D'+0x1D,0x5D,'O'+0x1D,'F'+0x1D,0x5D, 
};
unsigned char pub35_msg103[] = {
	'T'+0x1D,'I'+0x1D,'M'+0x1D,'E'+0x1D,0x5D,'A'+0x1D,'N'+0x1D,'D'+0x1D,0x5D,'T'+0x1D,'H'+0x1D,'E'+0x1D, 
};
unsigned char pub35_msg104[] = {
	'O'+0x1D,'N'+0x1D,'E'+0x1D,0x5D,'W'+0x1D,'A'+0x1D,'Y'+0x1D,0x5D,'I'+0x1D,'S'+0x1D,0x5D,'A'+0x1D, 
};
unsigned char pub35_msg105[] = {
	'S'+0x1D,'U'+0x1D,'R'+0x1D,'E'+0x1D,0x5D,'F'+0x1D,'I'+0x1D,'N'+0x1D,'D'+0x1D,0x82,0x5D,0x5D, 
};

void dopub35(UBYTE tnum, UBYTE pnum)
{

	UWORD amt ;
	UBYTE nomore,p ;



	changemusic = extragame ? 17 : 7 ;
	nomore = 0 ;

	memset(screenbuf3,0x5D,12L) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(screenbuf3) ;
	writegamemessage(pub35_dat1) ;
	writegamemessage(pub35_dat2) ;
	waitpadup() ;
	waitpad(0xFF) ;
	while ( !nomore )
	{
		for ( p=0; p<4 ; p++ )
			charscreen35(&(players[p]),p) ;
		writegamemessage(pub35_dat3) ;
		writegamemessage(pub35_dat4) ;
		writegamemessage(pub35_dat5) ;
		writegamemessage(pub35_dat6) ;

		memset(screenbuf3,0x5D,12L) ;
		writegamemessage(screenbuf3) ;
		amt = getamt35(4,players[pnum].gold) ;
		memset(screenbuf3,0x5D,12L) ;

		if ( amt<7L )
		{
			memset(screenbuf3,0x5D,12L) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_leavebad1) ;
			writegamemessage(pub35_leavebad2) ;
			writegamemessage(pub35_leavebad3) ;
			break ;

		}
		else
			if ( amt<10L )
		{
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg11) ;
			writegamemessage(pub35_msg12) ;
		}
		else
			if ( amt<20L )
		{
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg21) ;
			writegamemessage(pub35_msg22) ;
			writegamemessage(pub35_msg23) ;
		}
		else
			if ( amt<30L )
		{
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg31) ;
			writegamemessage(pub35_msg32) ;
			writegamemessage(pub35_msg33) ;
			writegamemessage(pub35_msg34) ;
		}
		else
			if ( amt<40L )
		{
			writegamemessage(pub35_msg41) ;
			writegamemessage(pub35_msg42) ;
			writegamemessage(pub35_msg43) ;
			writegamemessage(pub35_msg44) ;
			writegamemessage(pub35_msg45) ;
		}
		else
			if ( amt<50L )
		{
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg51) ;
			writegamemessage(pub35_msg52) ;
			writegamemessage(pub35_msg53) ;
			waitpadup() ;
			waitpad(0xFF) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg54) ;
			writegamemessage(pub35_msg55) ;
			writegamemessage(pub35_msg56) ;
		}
		else
			if ( amt<60L )
		{
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg61) ;
			writegamemessage(pub35_msg62) ;
			writegamemessage(pub35_msg63) ;
			waitpadup() ;
			waitpad(0xFF) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg64) ;
			writegamemessage(pub35_msg65) ;
			writegamemessage(pub35_msg66) ;
		}
		else
			if ( amt<70L )
		{
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg71) ;
			writegamemessage(pub35_msg72) ;
			writegamemessage(pub35_msg73) ;
			writegamemessage(pub35_msg74) ;
			waitpadup() ;
			waitpad(0xFF) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg75) ;
			writegamemessage(pub35_msg76) ;
			writegamemessage(pub35_msg77) ;
		}
		else
			if ( amt<80L )
		{
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg81) ;
			writegamemessage(pub35_msg82) ;
			writegamemessage(pub35_msg83) ;
			writegamemessage(pub35_msg84) ;
			waitpadup() ;
			waitpad(0xFF) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_msg85) ;
			writegamemessage(pub35_msg86) ;
			writegamemessage(pub35_msg87) ;
			writegamemessage(pub35_msg88) ;
		}
		else
			if ( amt<90L )
		{
			writegamemessage(pub35_msg91) ;
			writegamemessage(pub35_msg92) ;
			writegamemessage(pub35_msg93) ;
			writegamemessage(pub35_msg94) ;
			writegamemessage(pub35_msg95) ;
		}
		else
		{
			writegamemessage(pub35_msg101) ;
			writegamemessage(pub35_msg102) ;
			writegamemessage(pub35_msg103) ;
			writegamemessage(pub35_msg104) ;
			writegamemessage(pub35_msg105) ;
		}


		players[pnum].gold -= amt ;
		waitpadup();
		waitpad(0xFF) ;
		memset(screenbuf3,0x5D,12L) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(screenbuf3) ;
		writegamemessage(pub35_another) ;
		nomore = !(getmenuselection35(2,yesno35,NULL,NULL)) ;
		if ( nomore )
		{
			memset(screenbuf3,0x5D,12L) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(screenbuf3) ;
			writegamemessage(pub35_leavegood1) ;
			writegamemessage(pub35_leavegood2) ;

		}


	}

}

UBYTE dotransact35(UBYTE tnum, UBYTE tcode)
{
	UBYTE pnum;

	pnum = tcode&0x0F ;


	switch ( tcode&0xF0 )
	{
		case 0x10 : dohealer35(tnum,pnum) ; break ;
		case 0x20 : dosellclimb35(tnum,pnum) ; break ;
		case 0x30 : dosellbow35(tnum,pnum) ; break ;
		case 0x40 : dostable35(tnum,pnum) ; break ;
		case 0x50 : dobritish35(tnum,pnum) ; break ;
		case 0x60 : dopub35(tnum,pnum) ; break ;
		default : break ;

	}

	if ( (tcode&0xF0)!=0x50 )
		changemusic = calcmusic(peermap) ;


	return 1 ;
}
